/* Copyright (c) 2000-2001 ActiveState Tool Corporation.
   See the file LICENSE.txt for licensing information. */

/* -*- Mode: Java; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 2 -*-
 * window_functions.js
 * Common functions for accessing commdlg type things,
 * both ActiveState's and Netscape's.
 *
 * NOTE!
 * Only purely generic stuff should go in here at all, since it is utilized by many XUL files
 */
//TODO:
//  - Use a consistent naming scheme for all the public functions here.
//


//---- globals
var isLinux = false;
var infoService = Components.classes['@activestate.com/koInfoService;1'].
                  getService(Components.interfaces.koIInfoService);
if (infoService.platform.match(/^linux/)) {
    isLinux = true;
}

// Save the file pickers for efficiency and so that the last filter used is
// remembered.
var _gExeFilePicker = null;



//---- public methods

//precondition: defaultAction is one of "Yes", "No" "Cancel"
function yesNoCancel(prompt, defaultAction) {
    var obj = new Object ();
    obj.prompt = prompt;
    obj.res = defaultAction;
    var response = window.openDialog(
            "chrome://komodo/content/commdlg/yesnocancel.xul",
            "_blank",
            "centerscreen,chrome,modal,titlebar",
            obj);
    return obj.res;
}


function yesNoDialog(prompt, defaultAction) {
    var obj = new Object ();
    obj.prompt = prompt;
    obj.res = defaultAction;
    var hideCancel = true;
    var response = window.openDialog(
            "chrome://komodo/content/commdlg/yesnocancel.xul",
            "_blank",
            "centerscreen,chrome,modal,titlebar",
            obj,
            hideCancel);
    return obj.res;
}

// XXX this is becoming very overloaded, we need to clean it up
function alertDialog(prompt,
                     okIsDefault, hideCancel,
                     okLabel, cancelLabel,
                     text, checkboxLabel)
{
    var obj = new Object ();
    // "prompt" is the string displayed in the dialog. (must be defined)
    obj.prompt = prompt;
    obj.res = null;  // response
    // "okIsDefault" indicates that <Return> will fire the "Ok" button.
    // (defaults to true)
    if (typeof(okIsDefault) == "undefined") {
        obj.okIsDefault = true;
    } else {
        obj.okIsDefault = okIsDefault;
    }
    // "hideCancel" indicates if the <<Cancel>> button should be shown
    // (defaults to true, if "okIsDefault" is false this must be
    // true)
    if (!obj.okIsDefault) {
        obj.hideCancel = false;
    } else {
        if (typeof(hideCancel) == "undefined") {
            obj.hideCancel = true;
        } else {
            obj.hideCancel = hideCancel;
        }
    }
    // "okLabel" and "cancelLabel" are the button text strings
    if (typeof(okLabel) == "undefined" || !okLabel) {
        obj.okLabel = "OK";
    } else {
        obj.okLabel = okLabel;
    }
    if (typeof(cancelLabel) == "undefined" || !cancelLabel) {
        obj.cancelLabel = "Cancel";
    } else {
        obj.cancelLabel = cancelLabel;
    }
    if (typeof(checkboxLabel) == "undefined" || !checkboxLabel) {
        obj.checkboxLabel = null;
    } else {
        obj.checkboxLabel = checkboxLabel;
    }
    // "text" is an optional string to display in a multi-line textbox in the
    // dialog.
    if (typeof(text) == "undefined" || !text) {
        obj.text = null;
    } else {
        obj.text = text;
    }

    window.openDialog("chrome://komodo/content/commdlg/okcancel.xul",
                      "_blank",
                      "centerscreen,chrome,modal,titlebar",
                      obj);

    // Return the result, which is the text of the button clicked
    if (!checkboxLabel)
        return obj.res.res;    
    else
        return obj.res;
}


function promptDialog(prompt, defaultResponse, okLabel, cancelLabel, multiline) {
    if (typeof(multiline) == 'undefined') {
        multiline = false;
    }
    var obj = new Object();
    obj.prompt = prompt;
    obj.defaultResponse = defaultResponse;
    obj.okLabel = okLabel;
    obj.cancelLabel = cancelLabel;
    obj.multiline = multiline;
    var opts = "chrome,modal,titlebar";
    if (multiline) {
        opts += ",resizable=yes";
    }
    window.openDialog("chrome://komodo/content/commdlg/prompt.xul",
                      "_blank",
                      opts,
                      obj);
    return obj.res;
}

function dlg_openExeFile () {
    if (_gExeFilePicker == null) {
        _gExeFilePicker = Components.classes["@mozilla.org/filepicker;1"].
                          createInstance(Components.interfaces.nsIFilePicker);
        _gExeFilePicker.init(window, "Open File",
                             Components.interfaces.nsIFilePicker.modeOpen);

        if (isLinux) {
            _gExeFilePicker.appendFilter('All Files', '*');
        } else {
            _gExeFilePicker.appendFilter('Executable Files', '*.exe');
        }
    }
    if (_gExeFilePicker.show() == Components.interfaces.nsIFilePicker.returnOK) {
        // Don't return _gExeFilePicker.file -- let the caller access url and
        // local-file properties of _gExeFilePicker.
        return _gExeFilePicker; 
    }
    return null;
}


function safeAssignProp(obj, prop) {
    try {
        this[prop] = obj[prop];
    } catch(e) {
        this[prop] = null;
    }
}


function dlg_get_URL_andName(filePicker) {
    this.leafName = filePicker.file.leafName;
    this.fullName = filePicker.file.path;

    // Create a URL from the file path.
    this.url = LocalFileToURL(this.fullName);

    // Fix the url. File urls are horribly broken in Mozilla,
    // so they hacked together this fixup service.
    this.url = fixupUrl(this.url);
}

function doOpenURL(prompt) {
    obj = new Object();
    obj.prompt = prompt;
    obj.defaultResponse = "";
    obj.okLabel = "OK";
    obj.cancelLabel = "Cancel";
    obj.checkboxLabel = "Use WebDAV";
    window.openDialog("chrome://komodo/content/commdlg/promptWithCheckbox.xul",
                      "_blank",
                      "chrome,modal,titlebar",
                      obj);
    url = obj.res;
    if (url) {
        u = String(url);
        if (obj.checkbox && u.substring(0, 7) == 'http://') {
            url = "dav://" + u.substring(7, u.length);
        }
    }
    return url;
}


function BrowseForDir(current_dir) {
    var nsIFilePicker = Components.interfaces.nsIFilePicker;
    var fp = Components.classes["@mozilla.org/filepicker;1"].
             createInstance(nsIFilePicker);

    fp.init(window, "Select Folder", nsIFilePicker.modeGetFolder);
    if (current_dir) {
        try {
            var localFileObj = Components.classes["@mozilla.org/file/local;1"].
                               createInstance().
                               QueryInterface(Components.interfaces.nsILocalFile);
            localFileObj.initWithPath(current_dir);
            fp.displayDirectory = localFileObj;
        } catch(e) {
            ; // let the default directory remain.
            logError("Could not set the default directory for the "+
                     "directory picker to '" + current_dir + "': " +
                     e + "\n");
        }
    }
    if (fp.show() == nsIFilePicker.returnOK) {
        return fp.file.path;
    }
    return null;
}


function BrowseForFile(current, filters) {
    var nsIFilePicker = Components.interfaces.nsIFilePicker;
    var fp = Components.classes["@mozilla.org/filepicker;1"].
             createInstance(nsIFilePicker);

    fp.init (window, "Select File", nsIFilePicker.modeOpen);

    if (filters) {
        for (var i = 0; i < filters.length; i++) {
            var filter = filters[i];
            if (filter.length == 2) {
                var hackedTitle = filter[0];
                if (!isLinux) {
                    // isLinux adds the types to the title automatically;
                    // Windows doesn't.
                    hackedTitle += ' (' + filter[1].join(',') + ')';
                }
                fp.appendFilter(hackedTitle, filter[1].join('; '));
            }
        }
    }

    if (current) {
        try {
            var localFileObj = Components.classes["@mozilla.org/file/local;1"].
                               createInstance().
                               QueryInterface(Components.interfaces.nsILocalFile);
            localFileObj.initWithPath(current);
            fp.displayDirectory = localFileObj;
        } catch(e) {
            ; // let the default directory remain.
            logError("Could not set the default directory for the file "+
                     "picker to '" + current + "': " + e + "\n");
        }
    }
    if (fp.show() == nsIFilePicker.returnOK) {
        return fp.file.path;
    }
    return null;
}


function authDialog(title, message, loginname, allowAnonymous, allowPersist) {
    /* NOTE: if you change this usage, also change it in asJSDialogProxy.js */
    if (typeof(allowPersist)=="undefined") allowPersist = true;
    if (typeof(allowAnonymous)=="undefined") allowAnonymous = false;
    var obj = new Object ();
    obj.title = title;
    obj.message = message;
    obj.user = loginname;
    obj.allowAnonymous = allowAnonymous;
    obj.allowPersist = allowPersist;
    openWindowUniqueInstance("chrome://komodo/content/commdlg/authenticate.xul",
                      "komodo_authenticate",
                      "chrome,dialog,modal=yes",
                      obj);

    // Return the full object so caller can check and use whatever values they
    // wish.
    return obj;
}

function multiFileDialog(title,prompt,urls,okcancel)
{
    if (typeof(okcancel)=='undefined') okcancel = true;
    var obj = new Object();
    obj.URLs = urls;
    obj.okcancel = okcancel;
    obj.title = title;
    obj.prompt = prompt;
    openWindowUniqueInstance("chrome://komodo/content/editor/confirmClose.xul", 
                                "komodo_closeConfirm",
                                "chrome,close=no,modal,resizable=true",
                                obj);

    if (!obj || obj.ret == false) {
        // user pressed ESC or cancel
        return [];
    }
    return obj.URLs;
}
