    /* Copyright (c) 2000-2001 ActiveState Tool Corporation.
   See the file LICENSE.txt for licensing information. */

//XXX this implementation gives no chance for creating/destroying input view
//managers if people change the language on the fly.

function EditorScintillaView(viewmanager, mysci_widget) {
    ScintillaView.apply(this, [viewmanager, mysci_widget]);
    //XXX fix hardcoding of the ids below
    //dump("Language: "+this.py_inst.language+"\n");
    this._inputSplitter = document.getElementById('input-splitter');
    this._inputBox = document.getElementById('input-vbox');
    this._inputScin = document.getElementById('input-scin');
    this._inputBar = document.getElementById('inputbar-inner');
    this._inputBarButton = document.getElementById('inputBufferCloseButton');
    this._inputOuterBox = document.getElementById('input-outerbox');
    this._inputViewManager = null;
    this._splitterCollapsed = true;
}

// The following two lines ensure proper inheritance (see Flanagan, p. 144).
EditorScintillaView.prototype = new ScintillaView();
EditorScintillaView.prototype.constructor = EditorScintillaView;

EditorScintillaView.prototype.loadURI = function(language) {
    if (!ScintillaView.prototype.loadURI.apply(this, [language])) return 0;
    // XXX fix hardcoded language dependency
    if (this.py_inst.language == "XSLT") {
	this._inputViewManager = new MenuListViewManager('input-file-list', document.getElementById("input-scin"));
	this._splitterstate = this._inputSplitter.getAttribute('state');
    }
    return 1;
}

EditorScintillaView.prototype.activate = function() {
    ScintillaView.prototype.activate.apply(this);
    if (this._inputViewManager) {
	this._inputViewManager.activate();
	this._inputBar.removeAttribute('collapsed');
	if (this._splitterstate != this._inputSplitter.getAttribute('state')) {
	    this._inputSplitter.setAttribute('state', this._splitterstate);
	}
	
	if (this._inputViewManager.getCurrentView()) {
	    this._inputOuterBox.removeAttribute('collapsed');
	    this._inputBarButton.removeAttribute('disabled');
	} else {
	    this._inputOuterBox.setAttribute('collapsed', 'true');
	    this._inputBarButton.setAttribute('disabled', 'true');
	}
	
    } else {
	if (this._inputSplitter.getAttribute('state') == 'open')
	    this._inputSplitter.setAttribute('state','collapsed');
	this._inputSplitter.setAttribute('collapsed', 'true');
	this._inputBar.setAttribute('collapsed', 'true');
	this._inputOuterBox.setAttribute('collapsed', 'true');
    }
}

EditorScintillaView.prototype.deactivate = function() {
    if (this._inputViewManager) {
	this._inputOuterBox.setAttribute('collapsed', 'true');
	this._inputSplitter.setAttribute('collapsed', 'true');
	this._splitterstate = this._inputSplitter.getAttribute('state');
	this._inputViewManager.deactivate();
    }
    ScintillaView.prototype.deactivate.apply(this);
}

EditorScintillaView.prototype.canClose = function() {
    var result = false;
    if (!this._inputViewManager || this._inputViewManager.doFileCloseAll()) {
    	result = ScintillaView.prototype.canClose.apply(this);
    }
    return result;
}

EditorScintillaView.prototype.destructor = function() {
    if (this._inputViewManager) {
        this._inputViewManager.destructor();
    }
    ScintillaView.prototype.destructor.apply(this);
}

EditorScintillaView.prototype.showInput = function() {
    if (this._inputViewManager) {
        this._inputOuterBox.removeAttribute('collapsed');
	this._inputSplitter.removeAttribute('collapsed');
    }    
}

EditorScintillaView.prototype.updateUI = function() {
    ScintillaView.prototype.updateUI.apply(this);
    // ****************************************************
    // Note: the class browser is permanently disabled
    //       for the time being.
	/*
    if (showClassBrowser) {
      document.getElementById('codebox').setAttribute("style", "display:block;");
      document.getElementById('sidebar-splitter').setAttribute("style", "display:inline;");
      document.getElementById('sidebar-splitter').setAttribute("state", "collapsed");
      py_inst.registerClassBrowser(new classbrowser_receiver());
    } else {
      document.getElementById('codebox').setAttribute("style", "display:none;");
      document.getElementById('sidebar-splitter').setAttribute("style", "display:none;");
      //XXX py_inst.clearClassBrowser();
    }*/    
}    

