    /* Copyright (c) 2000-2001 ActiveState Tool Corporation.
   See the file LICENSE.txt for licensing information. */



function AbstractView(viewmanager) {
    this.manager = viewmanager;
};

AbstractView.prototype.loadURI = function(language) {
    return 1;
}

AbstractView.prototype.destructor = function() {
    // do nothing
}

AbstractView.prototype.installControllers = function () {
    logError("pure virtual call: AbstractView.prototype.installControllers\n");
}

AbstractView.prototype.removeControllers = function () {
    logError("pure virtual call: AbstractView.prototype.removeControllers\n");
}

AbstractView.prototype.activate = function() {
    logError("pure virtual call: AbstractView.prototype.activate\n");
}

AbstractView.prototype.deactivate = function () {
    logError("pure virtual call: AbstractView.prototype.deactivate\n");
}

// MH: I _think_ this makes sense in the base view ;-)  If not, they
// can throw an exception.  For a browser, for example, it
// could be the name of a bookmark, etc.
// Is this class truly supposed to be "abstract", or is it just a "base"?
// ie, would it be reasonable for NOT_IMPLEMENTED to be raised
// (meaning a "derived" class need not implement this at all)
AbstractView.prototype.gotoPosition = function( pos ) {
    logError("pure virtual call: AbstractView.prototype.gotoPosition\n");
}

AbstractView.prototype.PrintView = function() {
    logError("pure virtual call: AbstractView.prototype.PrintView\n");
}

AbstractView.prototype.viewAs = function(language) {
    logError("pure virtual call: AbstractView.prototype.viewAs\n");
    return false;
}

AbstractView.prototype.getLeafName = function() {
    var urllib = Components.classes["@activestate.com/koUrllib;1"].
        getService(Components.interfaces.koIUrllib);
    return urllib.unquote(this.leafName);
}

AbstractView.prototype.saveContents = function(url) {
    logError("pure virtual call: AbstractView.prototype.saveContents\n");
    return false;
}

AbstractView.prototype.doSave = function() {
    logError("pure virtual call: AbstractView.prototype.doSave\n");
}

AbstractView.prototype.doSaveAs = function() {
    logError("pure virtual call: AbstractView.prototype.doSaveAs\n");
}

AbstractView.prototype.doSaveAsTemplate = function() {
    logError("pure virtual call: AbstractView.prototype.doSaveAsTemplate\n");
}

AbstractView.prototype.doRemoteSaveAs = function() {
    logError("pure virtual call: AbstractView.prototype.doRemoteSaveAs\n");
}

AbstractView.prototype.canClose = function() {
    logError("pure virtual call: AbstractView.prototype.canClose\n");
}

AbstractView.prototype.close = function() {
    logError("pure virtual call: AbstractView.prototype.close\n");
}

AbstractView.prototype.HandleFileToSave = function() {
    var base_name = this.url == null ? "untitled document" : makeLeafName(this.url); 
    var res = yesNoCancel("Save changes to " + base_name + "?", "Yes");
    res = res.toLowerCase();
    if (res == "cancel") {
        return false;
    } else if (res == "yes"
	       && !this.doSave()) { // XXX needs testing.
        return false;
    }
    return true;
}

AbstractView.prototype.updateUI = function() {
    // do nothing
}

AbstractView.prototype.revert = function() {
    // do nothing
}

