/* Copyright (c) 2000-2001 ActiveState Tool Corporation.
   See the file LICENSE.txt for licensing information. */

// Methods used by File settings and properties window

// global
var hPrefWindow = null;
var initialTab   = arguments[2];
var view = opener.getFocusedView();
var propsDone = false; //only do file properites once per session

// Encoding
var koEncodingServices = Components.classes["@activestate.com/koEncodingServices;1"].
      getService(Components.interfaces.koIEncodingServices);
var encodingChanged = false;
var encodingList;
var lineEndingList;
var bombox;
var preserveExistingLineEndings;
var existingLineEndings;

function _obs() {
    var observerSvc = Components.classes["@mozilla.org/observer-service;1"].
          getService(Components.interfaces.nsIObserverService);
    observerSvc.AddObserver(this, 'currentView');
};

_obs.prototype = {
  Observe: function (view, topic, viewurl) {
    
 },

  QueryInterface: function (iid) {
    if (!iid.equals(nsIObserver))
    throw Components.results.NS_ERROR_NO_INTERFACE;
    return this;
}
};

function SetupDialog() {
    var viewManager = window.arguments[1]; // xxx - should just pass the prefset directly to us.
    if (!viewManager || !viewManager.getCurrentView())
        throw "Could not locate a preference set in the window args!";
    var prefset = viewManager.getCurrentView().prefs;

    hPrefWindow = new koPrefWindow(null, prefset);
    if( !hPrefWindow )
        throw "failed to create prefwindow";
    hPrefWindow.onsinglepageload();
    koDoSetOKCancel(doOk, doCancel);
    changeTab(initialTab, true);
    handleLanguageSensitivities();
    SetWindowLocation();
}

function changeTab(tab, startup) {
  var tabControl = document.getElementById("fileTabbox");
  var tab_id;
  var focus_id;
  switch (tab) {
      case "settings":
          tab_id = "settings_tab";
          focus_id = "showWhitespace";
          break;
      case "properties":
          tab_id = "properties_tab";
          focus_id = null;
          encodingList = document.getElementById('encodingList');
          lineEndingList = document.getElementById('lineEndingList');
          bombox = document.getElementById('bomCheckbox');
          preserveExistingLineEndings = document.getElementById('preserveExistingCheckbox');
          doFileProperties();
          doEncoding();
          doLineEndings();
          propsDone = true;
          break;
  }
  if (startup)  {  // only change if tabs are being changed when the dialog is loading
	var tb = document.getElementById(tab_id);
	tabControl.selectedTab = tb;
  }
  if (focus_id)  {
      var t = document.getElementById(focus_id);
      t.focus();      
  }
}

/* This function handles the disabled/enabled state of UI elements 
    depending on the language of the file open in the buffer */
function handleLanguageSensitivities()  {
    //XXX This handling is *kind of* bogus, but it works
    var linterLanguageService = view.py_inst.sourceFile.
                                  getLanguageBlockAtPosition(0).language.
                                  getLanguageService(Components.interfaces.koILinterLanguageService);                                  
    var completionLanguageService = view.py_inst.sourceFile.
                                  getLanguageBlockAtPosition(0).language.
                                  getLanguageService(Components.interfaces.koICompletionLanguageService);                                   
    
    if (!linterLanguageService)
        document.getElementById('editUseLinting').setAttribute('disabled', 'true');
    // This currently works under the presumption that a language will implement
    // both autocomplete and call tips, and not just one
    if (!completionLanguageService)  {
        document.getElementById('editUseAutoComplete').setAttribute('disabled', 'true');
        document.getElementById('editUseCallTips').setAttribute('disabled', 'true');
    }
}    

function getDateTimeString(datetime) {
    // XXX not localization friendly
    var months = ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"];
    var mins = datetime.getMinutes();
    if (mins.toString().length == 1)  {
        mins = '0' + mins;
    }
    var hours = datetime.getHours();
    var fulltime;
    if (hours > 12)  {
        hours = hours-12;
        fulltime = hours.toString() + ':' + mins + " PM";
    }
    else  {
        fulltime = hours.toString() + ':' + mins + " AM";
    }
    var dtstring = datetime.getDate() + ' ' + months[datetime.getMonth()] + ', ' + datetime.getFullYear() + ', ' + fulltime;
    return dtstring;
}

function doFileProperties()  {
    if (propsDone == true)
        return;

    var url = view.url;

    // init defaults
    var size = new Object();
    size.value = "Not Available";
    var read = false;
    var write = false;
    var createdate = "Not Available";
    var modifydate = "Not Available";
    var accessdate = "Not Available";
    
    if (url.search(/^(file\:)/) != -1)  {
        
        url = displayNameFromURL(url);
        var mode = new Object();
        var ino = new Object();
        var nlink = new Object();
        var uid = new Object();
        var gid = new Object();
        var atime = new Object();
        var mtime = new Object();
        var ctime = new Object();

        var koSysUtils = Components.classes["@activestate.com/koSysUtils;1"].
                  getService(Components.interfaces.koISysUtils);
        try {
            var fileStats = koSysUtils.Stat(url, mode, ino, ino, nlink, uid, gid, size, atime, mtime, ctime);
            size.value = size.value + ' bytes';
        }
        catch (e) {
            size.value = "Not Available";
            ctime.value = 0;
            mtime.value = 0;
            atime.value = 0;
        }

        // Do some date/time conversions - there has to be a neater way to do this!
        if (ctime.value) {
            var cdate = new Date(ctime.value*1000);
            createdate = getDateTimeString(cdate);
        }
        if (mtime.value) {
            var mdate = new Date(mtime.value*1000);
            modifydate = getDateTimeString(mdate);
        }
        if (atime.value) {
            var adate = new Date(atime.value*1000);
            accessdate = getDateTimeString(adate);
        }
        
        write = koSysUtils.Access(url, koSysUtils.W_OK);
        read = koSysUtils.Access(url, koSysUtils.R_OK);
    }
    
    // 'Name' field
    var nameField = document.getElementById('nameField');
    nameField.setAttribute('value', makeLeafName(url));
    
    // Language 'Type'
    // Leaving as text for the moment - will implement 'View As Language' perhaps
    // use <langlist> binding
    document.getElementById('typeList').setAttribute('value', view.py_inst.language);
    
    // Size
    document.getElementById('sizeField').setAttribute('value', size.value);
        
    // Location
    var path = displayPathFromURL(view.url);
    if (path != "")  {
        document.getElementById('locationField').setAttribute('value', path );
        document.getElementById('createdField').setAttribute('value', createdate);  // Created
        document.getElementById('modifiedField').setAttribute('value', modifydate);  // Last Modified
        document.getElementById('accessedField').setAttribute('value', accessdate);  // Last Accessed
    }
    else  {
        document.getElementById('locationField').setAttribute('value', "Unsaved");
        document.getElementById('createdField').setAttribute('value', "Unsaved");  // Created
        document.getElementById('modifiedField').setAttribute('value', "Unsaved");  // Last Modified
        document.getElementById('accessedField').setAttribute('value', "Unsaved");  // Last Accessed
    }

    // Read-write status
    var rwcheck = document.getElementById('rwCheckbox');
    if (read)  {
        var ro = !write;
        rwcheck.setAttribute('checked', ro);
    }
    else  {
        var rwbox = document.getElementById('rwbox');
        rwbox.removeChild(rwbox.firstChild);
        var text = document.getElementById('rwtext');
        text.setAttribute('value', 'This file has no read/write properties');
    }
}

function doEncoding()  {
    var current_encoding = view.py_inst.encoding;
    var count = new Object();
    var temp = new Object();
    koEncodingServices.enumerateEncodings(temp,count);
    var encodings = temp.value;
    var i;
    var menuitem;

    var init_hierarchy = koEncodingServices.encoding_hierarchy;

    var menupopup = opener.buildEncodingHierarchy(init_hierarchy, true, 'changeEncoding(this)');

    // Check to see if current encoding is in the list
    var enlistIndex = koEncodingServices.get_encoding_index(current_encoding.python_encoding_name);
    if (enlistIndex == -1)  {// not in list
        menuitem = document.createElementNS(XUL_NS, 'menuitem');
        menuitem.setAttribute('data', current_encoding.python_encoding_name);
        menuitem.setAttribute('label', current_encoding.friendly_encoding_name);
        menuitem.setAttribute('oncommand', 'changeEncoding(this)');
        menupopup.insertBefore(menuitem, menupopup.childNodes[0]);
    }
    
    encodingList.appendChild(menupopup);

    // Make sure current is selected
    if (enlistIndex == -1)  {
        encodingList.selectedIndex = 0;
    }
    else  {
        var item = document.getElementsByAttribute('data', current_encoding.python_encoding_name)[0];
        encodingList.selectedItem = item;
    }

    var encodingInfo = koEncodingServices.get_encoding_info(current_encoding.python_encoding_name);
    bombox.setAttribute('checked', current_encoding.byte_order_marker);
    doBOM(encodingInfo);
}

function doBOM(encodingInfo)  {
    var bom = encodingInfo.supports_byte_order_marker;
    if (bom)
        bombox.setAttribute('disabled', 'false');
    else
        bombox.setAttribute('disabled', 'true');

}

function changeEncoding(item)  {
    doBOM(koEncodingServices.get_encoding_info(item.getAttribute('data')));
    //encodingChanged = true;
}

function setEncoding()  {
    var koEncoding = Components.classes["@activestate.com/koEncoding;1"].
          createInstance(Components.interfaces.koIEncoding);

    koEncoding.python_encoding_name = encodingList.selectedItem.getAttribute('data');
    koEncoding.byte_order_marker = (bombox.getAttribute('disabled') == 'false' && bombox.getAttribute('checked') == 'true')

    var lang = view.py_inst.language;
    var language = view.py_inst.sourceFile.
                                  getLanguageBlockAtPosition(0).language;

    var warning = language.getEncodingWarning(koEncoding);
    
    if (warning == "" || 
        opener.alertDialog(warning + ' Are you sure that you want to change the encoding?', false, false, "Ok", "Cancel") == "Ok")  {
        try {
            view.py_inst.encoding = koEncoding;
        } catch(e) {
            if (opener.alertDialog("Unable to change file encoding to "+
                    koEncoding.python_encoding_name+".  "+
                    "The file may have characters that do not fit in "+
                    "this encoding.  Would you like to remove the "+
                    "characters and force the file to the encoding "+
                    "you have choosen?", false, false, "Ok", "Cancel") 
                == "Ok")  {
                
                try {
                    view.py_inst.forceEncodingFromEncodingName(koEncoding.python_encoding_name);
                } catch(e) {
                    opener.alertDialog("Unable to complete encoding conversion");
                    logError("Unable to change file encoding: "+e);
                }
            } else {
                logError("Unable to change file encoding: "+e);
            }
        }
        return true;
    }
    
    return false;
}

function doLineEndings()  {
    var menupopup = document.createElementNS(XUL_NS, 'menupopup');
    
    var menuitem = document.createElementNS(XUL_NS, 'menuitem');
    menuitem.setAttribute('label', 'DOS/Windows (\\r\\n)');
    menuitem.setAttribute('data', view.py_inst.EOL_CRLF.toString());
    menupopup.appendChild(menuitem);
    
    menuitem = document.createElementNS(XUL_NS, 'menuitem');
    menuitem.setAttribute('label', 'Macintosh (\\r)');
    menuitem.setAttribute('data', view.py_inst.EOL_CR.toString());
    menupopup.appendChild(menuitem);

    menuitem = document.createElementNS(XUL_NS, 'menuitem');
    menuitem.setAttribute('label', 'UNIX (\\n)');
    menuitem.setAttribute('data', view.py_inst.EOL_LF.toString());
    menupopup.appendChild(menuitem);

    lineEndingList.appendChild(menupopup);

    if (view.py_inst.new_line_endings == view.py_inst.EOL_LF) {
        lineEndingList.selectedIndex = 2;
    }
    else if (view.py_inst.new_line_endings == view.py_inst.EOL_CR) {
        lineEndingList.selectedIndex = 1;
    }
    else if (view.py_inst.new_line_endings == view.py_inst.EOL_CRLF) {
        lineEndingList.selectedIndex = 0;
    }

    existingLineEndings = view.py_inst.existing_line_endings; // Remembering this will save us an expensive operation later
    preserveExistingLineEndings.setAttribute('checked', existingLineEndings == view.py_inst.EOL_MIXED);
}

function _setResult(res) {
  if (window.arguments && window.arguments[0])
    window.arguments[0].res=res;
  return true;
}

function doOk() {
  if (!hPrefWindow.onSinglePageOK())
    return false;
  if (propsDone == true)  {
      if (!setEncoding())  {
          return false;
      }
      
      var newLineEndings = new Number(lineEndingList.selectedItem.getAttribute('data'));
      view.py_inst.new_line_endings = newLineEndings;
      if (preserveExistingLineEndings.getAttribute('checked') != 'true' &&
          newLineEndings != existingLineEndings ) {
          view.py_inst.existing_line_endings = newLineEndings;
      }
  }
  
  _setResult("ok");
  return true;
}

function doCancel() { 
  _setResult("cancel");
  return true;
}

function doUnload()  {
    SaveWindowLocation();
}    
