/* Copyright (c) 2000-2001 ActiveState Tool Corporation.
   See the file LICENSE.txt for licensing information. */

/* File related operations.
 * 
 * All code that deals with "views as files".
 * 
 * Really a mixmatch of things that should be in a "document" object.
 */


/* Update the titlebar 
   Have to keep in mind debugging state */
function updateTitlebar(view)  {
    var win = "ActiveState Komodo";
    var title = "";
    if (view != null)  {
        if (typeof(view.url)=='undefined' || !view.url) return;
        title = view.url;
        title = displayNameFromURL(title);
        if (view.isDirty())  {
            title = title.concat("*");
        } else  {
            title = title.replace(/\*$/, "");
            title = title.replace(/(\s)+$/, "");              
        }
        title = "["+ title + "]" + " - ";
    } else {
        title="";      
    }      
    
    var debug = "";
    var dbg = get_debugger_interface();
    if (dbg.state == DBG_STATE_BREAK) {
        debug = " - Debugger is in Break Mode"
    } else if (dbg.state == DBG_STATE_RUNNING) {
        debug = " - Debugger is Running";
    }

    window.title = (title + win + debug);
}

function doFileNew(language) {
    return viewManager.doFileNew(language);
}

function doFileOpen(url) {
    return viewManager.doFileOpen(url);
}

function doFileOpenDialog() {
    var obj = new Object ();
    obj.template = null;
    openWindowUniqueInstance("chrome://komodo/content/editor/templates/filenew.xul", 
                             "komodo_filenew",
                             "chrome,close=yes,modal",
                             obj);
    var template = obj.template;
    if (template != null)  {
        try {
            template = template.QueryInterface(Components.interfaces.koIBlankLanguageTemplate);
        } catch (e) {
            template = template.QueryInterface(Components.interfaces.koIFileTemplate);
            if (obj.addToToolbox) {
                AddTemplateToToolbox(template);
            }
            return viewManager.doNewFileTemplate(template);
        }
        // We have a blank template if we made it to here
        return viewManager.doFileNew(template.language);
    }
    return null; // shutup strict
}

function doFileQuit() {
  if (!viewManager.doFileCloseAll()) {
    return;
  }
  window.close();
}

function openFileInInputPane(filename) {
    // XXX this is currently hard-coding the input pane for xml files
    if (typeof(filename) == "undefined" || filename == "") {
        filename = null;
        var fp = dlg_openFile([['XML Input Files',['*.xml','*.xsl']]]);
        if (fp) {
            var file = new dlg_get_URL_andName(fp);
            filename = file.url;
        }
        if (!filename) return;
    }
    viewManager.getCurrentView()._inputViewManager.doFileOpen(filename);
}

function closeFileInInputPane() {
    view = viewManager.getCurrentView()._inputViewManager.closeView();
}

function closeFileInEditorPane() {
    view = viewManager.closeView();
}

function doPrint()  {
  // hook into views.js
  var v = gLastFocusedViewManager.getCurrentView();

  if (v == null) {
    logError("doPrint()::viewManager.getCurrentView() == null!");
  }
  else {
    v.PrintView();
  }

}

function doExportHTML()  {
  // hook into views.js
  var v = gLastFocusedViewManager.getCurrentView();

  if (v == null) {
    logError("doPrint()::viewManager.getCurrentView() == null!");
  }
  else {
    v.ExportHTML();
  }

}
function doPickRemoteDir() {
    // to test picking a directory
    fileBrowser = doFilebrowser("Pick Directory", "c:", Components.interfaces.nsIFilePicker.modeGetFolder);
    if (fileBrowser) {
        //dump("selected "+fileBrowser.directory+"\n");
        return fileBrowser.directory;
    }
    return null;
}

function doSaveAsRemoteFiles() {
    fileBrowser = doFilebrowser("Save File As", "c:", Components.interfaces.nsIFilePicker.modeSave);
    if (fileBrowser) {
        //dump("got "+fileBrowser.file+" from fileBrowser\n");
        return fileBrowser.file;
    }
    return null;
}

function doOpenRemoteFiles() {
    list = doBrowseForFiles();
    if (!list) return;
    for (var i = 0; i < list.length; i++) {
        doFileOpen(list[i]);
    }
}

function doBrowseForFiles() {
    var list;
    fileBrowser = doFilebrowser("Open Files", "c:");
    if (fileBrowser) {
        if (fileBrowser.filepaths && fileBrowser.filepaths.length > 0) {
            //if (fileBrowser.server) dump(fileBrowser.server.alias+": ");
            //dump("file selection is "+fileBrowser.filepaths[i]+"\n");
            return fileBrowser.filepaths;
        } else if (fileBrowser.file) {
            //if (fileBrowser.server) dump(fileBrowser.server.alias+": ");
            //dump("file selection is "+fileBrowser.file+"\n");
            list = new Array();
            list.push(fileBrowser.file);
            return list;
        } else if (fileBrowser.directory) {
            //if (fileBrowser.server) dump(fileBrowser.server.alias+": ");
            //dump("directory selection is "+fileBrowser.directory+"\n");
            list = new Array();
            list.push(fileBrowser.directory);
            return list;
        } else {
            //dump("There was no selection!\n");
        }
    }
    return null;
}

function doFilebrowser(title, path, mode, server, titles, types) {
   var fileBrowser = new Object();
   fileBrowser.filters = new Object();
   fileBrowser.displayDirectory = new Object();

   if (typeof(title) == "undefined" || !title)
       title = "Open File"; 
   fileBrowser.title = title;

   if (typeof(server) == "undefined" || !server)
       server = ""; // local computer
   fileBrowser.server = server;
   
   if (typeof(path) == "undefined" || !path)
       path = "c:\\";
   fileBrowser.displayDirectory.path = path;
   
   // get the mode
   if (typeof(mode) == "undefined" || !mode)
       mode = Components.interfaces.nsIFilePicker.modeOpen;
   fileBrowser.mode = mode;
   
   // set up the types
   if (typeof(titles) == "undefined" || !titles) {
       titles = ["All Files"];
       types = ["*.*"];
   }
   
   fileBrowser.filters.titles = titles;
   fileBrowser.filters.types = types;
   
   fileBrowser.defaultString = "";
   fileBrowser.retvals = new Object();
   fileBrowser.retvals.filepaths = null;
   fileBrowser.retvals.directory = null;
   fileBrowser.retvals.file = null;
   fileBrowser.retvals.buttonStatus = null;
   fileBrowser.retvals.server = null;

   var response = window.openDialog
     ("chrome://komodo/content/commdlg/filebrowser.xul",
                      "komodo_openremote",
                      "chrome,resizable=yes,dialog=yes,close=yes,dependent=yes,modal=yes",
                      fileBrowser);
   if (response) return fileBrowser.retvals;
   return null;
}


function doOpenPath(path, vm) {
    if (typeof(vm)=='undefined')
        vm = viewManager; 
    // convert to a moz url
    var url = fixupUrl(path);
    if (url.match(/\.kpf$/i)) {
        doOpenProjectFromURL(url);
    } else if (url.match(/\.ui$/i)) {
        try {
            var guiBuilder = Components.classes["@activestate.com/koGuiBuilderService;1"].
                        getService(Components.interfaces.koIGuiBuilderService);
            guiBuilder.Edit(url);
        } catch (e) {
            logError(e);
        }
    } else {
        vm.doFileOpen(url);
    }
 }