/* Copyright (c) 2000-2001 ActiveState Tool Corporation.
   See the file LICENSE.txt for licensing information. */

/* -*- Mode: Java; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 2 -*-
 *
 * goto.js -- Komodo Goto Line dialog
 */

var dialog;
var view;
var scimoz;
var numLinesInBuffer;

// String bundle
var gtKomodoBundle = opener.document.getElementById("bundle_komodo");

function GotoLoad() {
    dialog = {};
    dialog.ok = document.getElementById('ok');
    dialog.cancel = document.getElementById('cancel');
    dialog.num_lines = document.getElementById('num_lines');
    dialog.gototarget = document.getElementById("gototarget");
    
    view = opener.viewManager.getCurrentView();
    scimoz = view._scimoz;
    numLinesInBuffer = scimoz.lineCount;
    
    dialog.ok.setAttribute('label', gtKomodoBundle.getString( "goto_button" ));
    var text_label = gtKomodoBundle.getString( "goto_textlabel" );
    var numlines = (text_label + ' (1 - ' + numLinesInBuffer + ')');
    dialog.num_lines.setAttribute('value', numlines);

    // Get the contents of the input buffer (see comments in kombo.js) for the goto target.
    var inputBufferContents = opener.InputBuffer_Finish();
    if (inputBufferContents) {
        dialog.gototarget.setAttribute('value', inputBufferContents);
    }
    dialog.gototarget.focus();
    
    koDoSetOKCancel(doGoto, doCancel);

    SetWindowLocation();
}

function doGoto()  {
    if (_Goto(document.getElementById("gototarget").value)) {
        window.close();
    }
    else {
        dialog.gototarget.select();
    }
}

function _Goto(gotoString) {
  if (view == null)
      return false;
  var gotoInt = parseInt(gotoString, 10);
  if (!isNaN(gotoInt) && (gotoInt > 0)) {
    gotoInt--;
    if (numLinesInBuffer <= gotoInt) {
	  var goto_rangeerror = gtKomodoBundle.getString( "goto_rangeerror" );
	  alertDialog(goto_rangeerror + " " + numLinesInBuffer);
	  return false;
    }
    var pos = scimoz.positionFromLine(gotoInt);
    scimoz.gotoPos(pos);
	return true;
  } else {
	var goto_lineerror = gtKomodoBundle.getString( "goto_lineerror" );
	alertDialog(goto_lineerror);
	return false;
  }
  return false;
}

function doCancel() {
    window.close();
}

function GotoUnLoad()  {
    SaveWindowLocation();
}
