/* Copyright (c) 2000-2001 ActiveState Tool Corporation.
   See the file LICENSE.txt for licensing information. */
   
// Constants and global variables

var osPathService = Components.classes["@activestate.com/koOsPath;1"]
            .getService(Components.interfaces.koIOsPath);
            
var hPrefWindow = null;
var globalPrefSvc = Components.classes["@activestate.com/koPrefService;1"].getService(Components.interfaces.koIPrefService);
var pdkInfoSvc = Components.classes["@activestate.com/koPDKInfo;1"].getService(Components.interfaces.koIAppInfo);
var infoSvc = Components.classes["@activestate.com/koInfoService;1"].getService(Components.interfaces.koIInfoService);



var commandGenerators = Array(getTargetCommand, getDebuggingCommand,
                              getDependanciesCommand, forceCommand,
                              generateVerboseCommand, generateFailedUsesCommand,
                              generateHideConsoleCommand, generateCleanCommand,
                              generateExtraModulesCommand,
                              generateFilesCommand, generateVersionInfoCommand,
                              getScriptnameCommand);

var gVersionInfo = new Array(
   { 'userName' : 'Internal name', 'fieldName' : 'internalname', 'description' : 'Specify the internal name of the script, if one exists e.g. MyScript.pl' },
   { 'userName' : 'Original filename', 'fieldName' : 'originalfilename', 'description' : 'Specify the original name of the script, not including a path.' },
   { 'userName' : 'Company name', 'fieldName' : 'companyname', 'description' : 'Specify the company that produced the script e.g. ActiveState Corporation' },
   { 'userName' : 'Product name', 'fieldName' : 'productname', 'description' : 'Specify the name of the product with which the script is distributed e.g. Komodo' },
   { 'userName' : 'Binary file version', 'fieldName' : 'filenumber', 'description' : 'Specify the binary version number of the script, must in be in form number.number.number.number e.g. 12.3.2.1' },
   { 'userName' : 'Comments', 'fieldName' : 'comments', 'description' : 'Specify additional information that should be displayed for diagnostic purposes' },
   { 'userName' : 'Binary product version', 'fieldName' : 'productnumber', 'description' : 'Specify the binary version number of the product with which the script is distributed, must in be in form number.number.number.number e.g. 1.0.2.1' },
   { 'userName' : 'Legal trademarks', 'fieldName' : 'legaltrademarks', 'description' : 'Specify all trademarks and registered trademarks that apply to the script' },
   { 'userName' : 'File version', 'fieldName' : 'fileversion', 'description' : 'Specify the version number of the script e.g. "1.23 Beta"' },
   { 'userName' : 'Product version', 'fieldName' : 'productversion', 'description' : 'Specify the version number of the product with which the script is distributed e.g. "1.23 Beta"'},
   { 'userName' : 'File description', 'fieldName' : 'filedescription', 'description' : 'Specify a description of the script that is presented to the uset e.g. Perl application for analysing sales data' },
   { 'userName' : 'Legal copyright', 'fieldName' : 'legalcopyright', 'description' : 'Specify all copyright notices that apply to the script e.g. Copyright (C) 2000 ActiveState Corporation' }
);

var gFiles= new Array();
var gExtraModules = new Array();
var dialog = {};
var invocation = null;

var gOptions = new Array();
gOptions['app'] = new Array();
gOptions['app']['3.1'] = {
    "add" : "-add=",
    "bind" : "-bind=",
    "clean" : "-clean",
    "debug" : "-debug=",
    "dependent" : "",
    "exclude" : "-xclude",
    "exe" : "-exe=",
    "freestanding" : "-freestanding",
    "gui" : "-gui",
    "info" : "-info=",
    "report" : "-report",
    "script" : "-script=",
    "verbose" : "-verbose"
};
gOptions['app']['4'] = {
    "add" : "--add ",
    "bind" : "--bind ",
    "blib" : "--blib ",
    "clean" : "--clean",
    "debug" : "--debug ",
    "dependent" : "--dependent ",
    "exclude" : "--xclude",
    "exe" : "--exe ",
    "explain" : "--explain ",
    "force" : "--force ",
    "freestanding" : "--freestanding",
    "gui" : "--gui",
    "icon" : "--icon ",
    "info" : "--info ",
    "lib" : "--lib ",
    "nocompress" : "--nocompress",
    "nologo" : "--nologo",
    "tmpdir" : "--tmpdir ",
    "trim" : "--trim ",
    "script" : "",
    "verbose" : "--verbose",
    "version" : "--version"
};
gOptions['app']['4.1'] = gOptions['app']['4'];

gOptions['ctrl'] = new Array();
gOptions['ctrl']['3.1'] = {
    "add" : "-add=",
    "bind" : "-bind=",
    "clean" : "-clean",
    "debug" : "-debug=",
    "exclude" : "-xclude",
    "exe" : "-exe=",
    "freestanding" : "-freestanding",
    "info" : "-info=",
    "nodeps" : "-nodeps",
    "report" : "-report",
    "script" : "-script=",
    "template" : "-template",
    "verbose" : "-verbose"
};
gOptions['ctrl']['4'] = {
    "add" : "--add ",
    "bind" : "--bind ",
    "blib" : "--blib ",
    "clean" : "--clean",
    "debug" : "--debug ",
    "dependent" : "--dependent ",
    "exclude" : "--xclude",
    "exe" : "--exe ",
    "explain" : "--explain ",
    "force" : "--force ",
    "freestanding" : "--freestanding",
    "icon" : "--icon ",
    "info" : "--info ",
    "lib" : "--lib ",
    "nocompress" : "--nocompress",
    "nologo" : "--nologo",
    "template" : "--template ",
    "tmpdir" : "--tmpdir ",
    "trim" : "--trim ",
    "script" : "",
    "verbose" : "--verbose",
    "version" : "--version"
};
gOptions['ctrl']['4.1'] = gOptions['ctrl']['4'];

gOptions['svc'] = new Array();
gOptions['svc']['3.1'] = gOptions['app']['3.1'];
gOptions['svc']['3.1']['gui'] = '';
gOptions['svc']['4'] = gOptions['svc']['3.1']; // unchanged
gOptions['svc']['4.1'] = {
    "add" : "--add ",
    "bind" : "--bind ",
    "blib" : "--blib ",
    "clean" : "--clean",
    "debug" : "--debug ",
    "dependent" : "--dependent ",
    "exclude" : "--xclude",
    "exe" : "--exe ",
    "explain" : "--explain ",
    "force" : "--force",
    "freestanding" : "--freestanding",
    "help" : "--help ",
    "icon" : "--icon ",
    "info" : "--info ",
    "lib" : "--lib ",
    "nocompress" : "--nocompress",
    "nologo" : "--nologo",
    "script" : "--script ",
    "tmpdir" : "--tmpdir ",
    "trim" : "--trim ",
    "verbose" : "--verbose"
};
gOptions['svc']['4.1']['gui'] = '';

var pdkLastVersion = 4.1;
var pdkVersion;
var gCurrentOpts = null;

function getOption(name) {
    if (!gCurrentOpts || typeof(gCurrentOpts) == "undefined") {
        var selecteditem = dialog.pdkTypeMenu.getAttribute('value');  
        gCurrentOpts = gOptions[selecteditem][pdkVersion];
    }
    if (typeof(gCurrentOpts[name]) != 'undefined') {
        return gCurrentOpts[name];
    }
    return '';
}

function onPerlAppLoad() {
    var view = opener.gLastFocusedViewManager.getCurrentView();
    var installed = false;
    var haveLicense = false;
       
    try
    {
        if (pdkInfoSvc.installed) {
            if (pdkInfoSvc.version > pdkLastVersion) {
                pdkVersion = parseFloat(pdkLastVersion);
            } else {
                pdkVersion = parseFloat(pdkInfoSvc.version);
            }
            haveLicense = pdkInfoSvc.haveLicense;
            installed = true;
        }            
    } catch (e) {
        logError('Error retrieving PDK information: ' + e);
    }

    if (infoSvc.isWindows) {
        var majorVersion = new Object();
        var minorVersion = new Object();
        var buildNumber = new Object();
        var platformID = new Object();
        var csdVersion = new Object();
        
        infoSvc.windows_GetVersionEx(majorVersion, minorVersion, buildNumber,
                                     platformID, csdVersion);
        platformID = platformID.value;
        if (pdkVersion < 4.0 && platformID == infoSvc.VER_PLATFORM_WIN32_WINDOWS) {
            window.openDialog("chrome://komodo/content/pdk/perlapp-alert.xul",
                              "_blank",
                              "chrome,dialog,close,modal",
                              'win9x');
            window.close();
            return;
        }        
    }
    
    if (!installed) {
        window.openDialog("chrome://komodo/content/pdk/perlapp-alert.xul",
                          "_blank",
                          "chrome,dialog,close,modal",
                          'notfound');
        window.close();
        return;
    } else if (pdkVersion < 3) {
        window.openDialog("chrome://komodo/content/pdk/perlapp-alert.xul",
                          "_blank",
                          "chrome,dialog,close,modal",
                          'old');
        window.close();
        return;
    } else if (!haveLicense) {
        window.openDialog("chrome://komodo/content/pdk/perlapp-alert.xul",
                          "_blank",
                          "chrome,dialog,close,modal",
                          'unlicensed');
        window.close();
        return;
    }        

    if (opener.gLastFocusedViewManager.doDirtyDocsExist()) {
        var response = yesNoCancel("Save all changed documents before building Perl application?",
                                   "Yes");

        if (response == "Yes") {
            result = opener.gLastFocusedViewManager.doSaveAll();
        } else if (response == "No") {
        } else { // response == "Cancel"
            window.close();
            return;
        }
    }
    invocation = Components.classes["@activestate.com/koInvocation;1?type=PerlApp"].createInstance();
    var catOb = new Object();
    var instOb = new Object();
    invocation.getDefaultPreferences(catOb, instOb);
    invocation.currentCategoryPreferences = catOb.value;
    invocation.currentInstancePreferences = instOb.value;

    dialog.scriptname = document.getElementById('scriptname');

    dialog.pdkTypeMenu = document.getElementById('pdkType');
    dialog.targetname = document.getElementById('targetname');
    dialog.dependanciesMenu = document.getElementById('dependancies');
    dialog.debuggingMenu = document.getElementById('debugging');

    dialog.verbose = document.getElementById('verbose');
    dialog.failedUses = document.getElementById('failedUses');
    dialog.hideConsole = document.getElementById('hideConsole');
    dialog.clean = document.getElementById('clean');
    dialog.force = document.getElementById('forceOverwrite');
    
    dialog.hostname = document.getElementById('hostname');
    dialog.port = document.getElementById('port');

    dialog.extraModules = document.getElementById('extraModules');
    dialog.moduleName = document.getElementById('moduleName');   
    dialog.addModule = document.getElementById('addModule');
    dialog.deleteModule = document.getElementById('deleteModule');
    document.getElementById('extraModules').outlinerBoxObject.view = gExtraModulesView;

    dialog.versionFieldPrompt = document.getElementById('versionFieldPrompt');

    dialog.dataFiles = document.getElementById('dataFiles');
    dialog.addFile = document.getElementById('addFile');
    dialog.editFile = document.getElementById('editFile');
    dialog.deleteFile = document.getElementById('deleteFile');
    document.getElementById('dataFiles').outlinerBoxObject.view = gFilesView;

    document.getElementById('versionInfo').outlinerBoxObject.view = gVersionInfoView;
    dialog.updateVersionField = document.getElementById('updateVersionField');
    dialog.clearVersionField = document.getElementById('clearVersionField');
    dialog.versionInfoValue = document.getElementById('versionInfoValue');
    
    dialog.commandstring = document.getElementById('commandstring');

    // Recover the preference    
    var perlAppPrefSet = globalPrefSvc.prefs.getPref('PerlApp')
    
    hPrefWindow = new koPrefWindow(null, perlAppPrefSet);
    if( !hPrefWindow )
        throw "failed to create prefwindow";
    hPrefWindow.onsinglepageload();
                                    
    var extraModulesPref = perlAppPrefSet.getPref('extraModules').QueryInterface(Components.interfaces.koIOrderedPreference);
    var i;
    for (i=0; i < extraModulesPref.length; ++i) {
        gExtraModules.push(extraModulesPref.getStringPref(i));
    }
    
    var dataFilesPref = perlAppPrefSet.getPref('dataFiles').QueryInterface(Components.interfaces.koIOrderedPreference);
    for (i=0; i < dataFilesPref.length; ++i) {
        var dataFile = new Object();
        var dataPref = dataFilesPref.getPref(i);
        dataFile.sourceFile = dataPref.getStringPref("sourceFile");
        dataFile.destinationFile = dataPref.getStringPref("destinationFile");
        gFiles.push(dataFile);
    }
    
    var versionInfoPref = perlAppPrefSet.getPref('versionInfo')
    for (i=0; i < gVersionInfo.length; ++i) {
        if (versionInfoPref.hasStringPref(gVersionInfo[i].fieldName)) {
            gVersionInfo[i].fieldValue = versionInfoPref.getStringPref(gVersionInfo[i].fieldName);
        }
        else {
            gVersionInfo[i].fieldValue = null;
        }
    }

    if (view && view.py_inst.url) {
        var localFile = URLToLocalFile(view.py_inst.url).path;
        var targetValue = osPathService.withoutExtension(localFile) + '.exe';
        if (dialog.scriptname.value != localFile) {
            // The pref isn't for the current script
            dialog.scriptname.value = localFile;
            dialog.targetname.value = targetValue;
        }
        dialog.userExeName = targetValue; // squirrel this away in case we change to perlctrl
    }
    else {
        dialog.userExeName = ""; // squirrel this away in case we change to perlctrl
    }
    
    changePDKType();
    changeDependancies();
    changeDebuggingType();
    changeFailedUses();
    changeHideConsole();

    changeModuleName();
    gExtraModulesView.refresh();
    gFilesView.selectionChanged();
    gFilesView.refresh();
    gVersionInfoView.selection.select(0);
    gVersionInfoView.selectionChanged();
    
    setCommandString();
    
    SetWindowLocation();
}

function onPerlAppUnload()  {
    SaveWindowLocation();
    opener.focus();
}

function getScriptnameCommand() {
    var opt = getOption('script');
    if (!opt)
        return '\"' + dialog.scriptname.value + '\"';
    return opt + '\"' + dialog.scriptname.value + '\"';
}

function changeScriptname() {
    setTargetnameFromSourcenameIfNeeded();

    setCommandString();
}

function getPdkCommand() {
    var selecteditem = dialog.pdkTypeMenu.getAttribute('value');  

    if (selecteditem == 'app') {
        return 'PerlApp';
    } else if (selecteditem == 'svc') {
        return 'PerlSvc';
    } else if (selecteditem == 'ctrl') {
        return 'PerlCtrl';
    }
    return null;
}

function changePDKType()  {
    var selecteditem = dialog.pdkTypeMenu.getAttribute('value');  

    dialog.failedUses.disabled = true;
    dialog.failedUses.setAttribute('checked','false');
    if (selecteditem == 'app') {
        if (pdkVersion < 4) {
            dialog.failedUses.disabled = false;
            dialog.failedUses.setAttribute('checked','true');
        }
        dialog.hideConsole.disabled = false;
        dialog.targetname.disabled = false;
        setTargetnameFromSourcenameIfNeeded('app')
        dialog.userExeName = null;
    } else if (selecteditem == 'svc') {
        if (pdkVersion < 4.1) {
            dialog.failedUses.removeAttribute('collapsed');
            dialog.failedUses.disabled = false;
            dialog.failedUses.setAttribute('checked','true');
        }
        dialog.hideConsole.disabled = true;
        dialog.hideConsole.setAttribute('checked', 'false');
        dialog.targetname.disabled = false;
        setTargetnameFromSourcenameIfNeeded('svc')
        dialog.userExeName = null;
    } else if (selecteditem == 'ctrl') {
        if (pdkVersion < 4) {
            dialog.failedUses.disabled = false;
            dialog.failedUses.setAttribute('checked','true');
        }
        dialog.hideConsole.disabled = true;
        dialog.hideConsole.setAttribute('checked', 'false');
        dialog.targetname.disabled = true;
        if (dialog.userExeName == null) {
            dialog.userExeName = dialog.targetname.value;
        }
        setTargetnameFromSourcenameIfNeeded('ctrl');
    }
    gCurrentOpts = gOptions[selecteditem][pdkVersion];
    setCommandString();    
}

function getTargetCommand()  {
    var opt = getOption('exe');
    if (!dialog.targetname.disabled && dialog.targetname.value && opt)
    {
        return opt + "\"" + dialog.targetname.value + "\"";
    }
    return '';
}

function setTargetnameFromSourcenameIfNeeded(buildType) {
    if (buildType == 'ctrl') {
        dialog.targetname.value = osPathService.withoutExtension(dialog.scriptname.value) + '.dll';
    }
    else {
        // Restore the user's name for the EXE in case we are switching from PerlCtrl
        if (dialog.userExeName) {
            dialog.targetname.value = dialog.userExeName;
        }            
    }        
}

function changeTargetname() {
    setCommandString(); 
}    

function getDependanciesCommand()  {
    var selecteditem = dialog.dependanciesMenu.getAttribute('value');
    var freestanding = getOption('freestanding');
    if (selecteditem == 'freestanding') {
        return freestanding;
    } else if (selecteditem == 'freestanding_noperl56') {
        return freestanding + ' ' + getOption('exclude');
    }
    // selecteditem == 'dependent'
    return getOption('dependent');
}

function changeDependancies(selecteditem) {
    setCommandString(); 
}    

function getDebuggingCommand() {
    var selecteditem = dialog.debuggingMenu.getAttribute('value');
    var opt = getOption('debug');
    if (selecteditem == 'none' || !opt) {
        return '';
    } else if (selecteditem == 'localPdk') {
        return opt;
    } else if (selecteditem == 'localKomodo') {
        return opt + '-';
    } else if (selecteditem == 'other') {
        return opt + dialog.hostname.value + ':' + dialog.port.value;
    }
    return '';
}

function changeDebuggingType() {
    var selecteditem = dialog.debuggingMenu.getAttribute('value');
        
    dialog.hostname.disabled = true;
    dialog.port.disabled = true;
    dialog.hostname.value = 'localhost';
    dialog.port.value = '2000';
    
    if (selecteditem == 'localKomodo') {
        dialog.hostname.value = 'localhost';
        dialog.port.value = new String(globalPrefSvc.prefs.getLongPref('remotePerlListenPort'));
    } else if (selecteditem == 'other') {
        dialog.hostname.disabled = false;        
        dialog.port.disabled = false;
    }

    setCommandString();    
}

function changeHostname() {
    setCommandString();
}    

function changePort() {
    setCommandString();
}

function generateVerboseCommand() {
    var opt = getOption('verbose');
    if (dialog.verbose.getAttribute('checked') == 'true' && opt) {
        return opt;
    }
    return ''
}

function changeVerbose() {
    setCommandString();
}


function generateFailedUsesCommand() {
    var opt = getOption('report');
    if (dialog.failedUses.getAttribute('checked') == 'true' && opt) {
        return opt;
    }
    return ''
}

function changeFailedUses() {
    var selecteditem = dialog.pdkTypeMenu.getAttribute('value');
    if (selecteditem == 'app') {
        if (dialog.failedUses.getAttribute('checked') == 'true') {
            dialog.hideConsole.setAttribute('checked', 'false')
            dialog.hideConsole.disabled = true;
        }
        else {
            dialog.hideConsole.disabled = false;
        }
    }
    
    setCommandString(); 
}

function generateHideConsoleCommand() {
    var opt = getOption('gui');
    if (dialog.hideConsole.getAttribute('checked') == 'true' && opt) {
        return opt;
    }
    return '';
}

function changeHideConsole() {
    if (pdkVersion < 4) {
        if (dialog.hideConsole.getAttribute('checked') == 'true') {
            dialog.failedUses.setAttribute('checked', 'false')
            dialog.failedUses.disabled = true;
        }
        else {
            dialog.failedUses.disabled = false;
        }
    }
    
    setCommandString(); 
}

function forceCommand() {
    var opt = getOption('force');
    if (dialog.force.getAttribute('checked') == 'true' && opt) {
        return opt;
    }
    return '';
}

function generateCleanCommand() {
    var opt = getOption('clean');
    if (dialog.clean.getAttribute('checked') == 'true') {
        return opt;
    }
    return '';
}

function changeClean() {
    setCommandString(); 
}

function restoreDefaultGeneral() {
    // XXX this should use default prefs
    var defaultPerlAppPrefs = Components.classes["@activestate.com/koPreferenceSet;1"]
            .createInstance(Components.interfaces.koIPreferenceSet);

    // Leave scriptname untouched
    dialog.pdkTypeMenu.selectedIndex = 0;
    // Leave targetname untouched, it will be fixed, if necessary, by changePDKType
    dialog.dependanciesMenu.selectedIndex = 0;
    dialog.verbose.setAttribute("checked", "true");
    dialog.failedUses.setAttribute("checked", "false");
    dialog.hideConsole.setAttribute("checked", "false");
    dialog.clean.setAttribute("checked", "false");
    dialog.debuggingMenu.selectedIndex = 0;
    dialog.hostname.value = "localhost";
    dialog.port.value = new String(globalPrefSvc.prefs.getLongPref('remotePerlListenPort'));

    changePDKType();
    changeDependancies();
    changeDebuggingType();
    changeFailedUses();
    changeHideConsole();

    setCommandString();    
}    

// Extra modules tab

var gExtraModulesView = {
    rowCount : 0,
    outliner : null,
    isSeparator : function(index) {return false;},
    isContainer : function(index) {return false;},
    setOutliner : function(out) { this.outliner = out; },
    getCellText : function(row,column){
        return gExtraModules[row];
    },
    getRowProperties : function(row,prop){},
    getColumnProperties : function(column,prop){},
    getCellProperties : function(row,prop){},

    refresh : function() {
        this.rowCount = gExtraModules.length;
        this.outliner.rowCountChanged(0, this.rowCount);
        this.outliner.invalidate();
    },

    selectionChanged : function() {
        if (this.selection.currentIndex >= gExtraModules.length) {
            logDebug('selection past end of modules list');
        }            
        if (this.selection.currentIndex != -1) {
            dialog.moduleName.value = gExtraModules[this.selection.currentIndex];
        }
        changeModuleName();
    }
};

// XXX - This should be centralized through all of Komodo
Array.prototype.find = function(item) {
    for(var index = 0; index < this.length; ++index) {
        if (this[index] == item) {
            return index;
        }            
    }
    return -1;    
}

function generateExtraModulesCommand() {
    if (gExtraModules.length == 0) {
        return '';
    }
    var command = getOption('add') + gExtraModules[0];
    for(var index = 1; index < gExtraModules.length; ++index) {
        command += ';' + gExtraModules[index];
    }
    return command;
}    

function changeModuleName() {
    if (dialog.moduleName.value == '') {
        dialog.addModule.disabled = true;
        dialog.deleteModule.disabled = true;
    }
    else
    {
        var index = gExtraModules.find(dialog.moduleName.value);
        gExtraModulesView.selection.select(index);
        if (index == -1) {
            dialog.addModule.disabled = false;
            dialog.deleteModule.disabled = true;
        } else
        {
            dialog.addModule.disabled = true;
            dialog.deleteModule.disabled = false;
        }
    }
}    

function addModule() {
    gExtraModules.push(dialog.moduleName.value);
    gExtraModulesView.refresh();
    changeModuleName();
    setCommandString();
}    

function deleteModule() {
    var index = gExtraModules.find(dialog.moduleName.value);
    if (index == -1) {
        logDebug('Module selected for delete doesn\'t exist:' + dialog.moduleName.value);
    } else
    {
        gExtraModules.splice(index, 1);
        dialog.moduleName.value = '';
        gExtraModulesView.selection.select(-1);
        gExtraModulesView.refresh();
        changeModuleName();
        setCommandString();
    }
}

function deleteAllModules() {
    gExtraModules = Array();
    dialog.moduleName.value = '';
    gExtraModulesView.selection.select(-1);
    gExtraModulesView.refresh();
    changeModuleName();
    setCommandString();
}    

// Files tab

var gFilesView = {
    rowCount : 0,
    outliner : null,
    isSeparator : function(index) {return false;},
    isContainer : function(index) {return false;},
    setOutliner : function(out) { this.outliner = out; },
    getCellText : function(row,column){
      if (column=="sourceColumn")  {
        return gFiles[row].sourceFile;
      }
      else if (column=="destinationColumn"){
        return gFiles[row].destinationFile;
      }
      return null;
    },
    getRowProperties : function(row,prop){},
    getColumnProperties : function(column,prop){},
    getCellProperties : function(row,prop){},

    refresh : function() {
        this.rowCount = gFiles.length;
        this.outliner.rowCountChanged(0, this.rowCount);
        this.outliner.invalidate();
    },

    selectionChanged : function() {
        if (this.selection.currentIndex == -1) {
            dialog.deleteFile.disabled = true;
            dialog.editFile.disabled = true;
        } else {
            dialog.deleteFile.disabled = false;
            dialog.editFile.disabled = false;
        }            
    }
};

function generateFilesCommand() {
    if (gFiles.length == 0) {
        return '';
    }
    var command = getOption('bind') + gFiles[0].sourceFile + "(" + gFiles[0].destinationFile + ")";
    for(var index = 1; index < gFiles.length; ++index) {
        command += ';' + gFiles[index].sourceFile + "(" + gFiles[index].destinationFile + ")";
    }
    return command;
}

function addFile() {
    var obj = new Object ();

    obj.sourceFile = '';
    obj.destinationFile = '';
    
    openWindowUniqueInstance("chrome://komodo/content/pdk/perlapp-fileadd.xul", 
                       "kodialog", 
                       "chrome,dialog=no,close=yes,modal",
                        obj);

    if (obj.sourceFile && obj.destinationFile) { 
        gFiles.push(obj);
        gFilesView.refresh();
        setCommandString();
    }
}

function editFile() {
    var obj = new Object ();

    var currentIndex = gFilesView.selection.currentIndex;

    obj.sourceFile = gFiles[currentIndex].sourceFile;
    obj.destinationFile = gFiles[currentIndex].destinationFile;
    
    openWindowUniqueInstance("chrome://komodo/content/pdk/perlapp-fileadd.xul", 
                       "kodialog", 
                       "chrome,dialog=no,close=yes,modal",
                        obj);

    if (obj.sourceFile && obj.destinationFile) { 
        gFiles[currentIndex] = obj;
        gFilesView.refresh();
        setCommandString();
    }
}   

function deleteFile() {
    var index = gFilesView.selection.currentIndex;
    if (index == -1) {
        logDebug('File selected for delete doesn\'t exist:' + index);
    } else
    {
        gFiles.splice(index, 1);
        gFilesView.selection.select(-1);
        gFilesView.refresh();
        setCommandString();
    }
}

function deleteAllFiles() {
    gFiles = Array();
    gFilesView.selection.select(-1);
    gFilesView.refresh();
    setCommandString();
}    

// Version tab

var gVersionInfoView = {
    rowCount : gVersionInfo.length,
    outliner : null,
    isSeparator : function(index) {return false;},
    isContainer : function(index) {return false;},
    setOutliner : function(out) { this.outliner = out; },
    getCellText : function(row,column){
      if (column=="fieldColumn")  {
        return gVersionInfo[row].userName;
      }
      else if (column=="valueColumn"){
        if (gVersionInfo[row].fieldValue == null) {
            return '<Use default>'
        } else {
            return gVersionInfo[row].fieldValue;
        } 
      }
      return null;
    },
    getRowProperties : function(row,prop){},
    getColumnProperties : function(column,prop){},
    getCellProperties : function(row,prop){},

    refresh : function() {
        this.outliner.invalidate();
    },

    selectionChanged : function() {
        var selText;
        if (dialog.versionFieldPrompt.hasChildNodes())  {
            dialog.versionFieldPrompt.removeChild(dialog.versionFieldPrompt.firstChild);
        }
        if (this.selection.currentIndex == -1)
        {
            selText = document.createTextNode("Select a version field to see information about it");
            dialog.versionFieldPrompt.appendChild(selText);
            dialog.versionInfoValue.value = "";
            dialog.clearVersionField.disabled = true;
            dialog.versionInfoValue.disabled = true;            
        }
        else
        {
            selText = document.createTextNode(gVersionInfo[this.selection.currentIndex].description);
            dialog.versionFieldPrompt.appendChild(selText);
            if (gVersionInfo[this.selection.currentIndex].fieldValue == null) {
                dialog.versionInfoValue.value = '';
            }
            else {
                dialog.versionInfoValue.value = gVersionInfo[this.selection.currentIndex].fieldValue;
            }
            dialog.clearVersionField.disabled = false;
            dialog.versionInfoValue.disabled = false;            
        }            
    }
};

function generateVersionInfoCommand() {
    var command = getOption('info') + "\"";
    var hitone = false;
    
    for (var i=0; i < gVersionInfo.length; ++i) {
        if (gVersionInfo[i].fieldValue != null) {
            if (hitone) {
                command += ';'
            }
            else {
                hitone = true;
            }                
            command += gVersionInfo[i].fieldName + "=" + gVersionInfo[i].fieldValue;
        }
    }

    if (hitone) {
        return command + "\"";
    }
    return "";
}

function changeVersionInfoValue() {

}    

function updateVersionField() {
    gVersionInfo[gVersionInfoView.selection.currentIndex].fieldValue = dialog.versionInfoValue.value;
    gVersionInfoView.refresh();
    setCommandString();
}

function clearVersionField() {
    gVersionInfo[gVersionInfoView.selection.currentIndex].fieldValue = null;
    gVersionInfoView.refresh();
    setCommandString();
}

function restoreDefaultVersionInfo() {
    for (var i=0; i < gVersionInfo.length; ++i) {
        gVersionInfo[i].fieldValue = null;
    }

    gVersionInfoView.refresh();
    setCommandString(); 
}    

function savePrefs() {
    hPrefWindow.onSinglePageOK();

    var perlAppPrefSet = globalPrefSvc.prefs.getPref('PerlApp')
    var extraModulesPrefs = perlAppPrefSet.getPref('extraModules').QueryInterface(Components.interfaces.koIOrderedPreference);
    extraModulesPrefs.reset();
    var i;
    for (i =0; i < gExtraModules.length; ++i) {
        extraModulesPrefs.appendStringPref(gExtraModules[i]);
    }

    var dataFilesPrefs = perlAppPrefSet.getPref('dataFiles').QueryInterface(Components.interfaces.koIOrderedPreference);
    dataFilesPrefs.reset();
    for (i=0; i < gFiles.length; ++i) {
        dataPref = Components.classes["@activestate.com/koPreferenceSet;1"]
                .createInstance(Components.interfaces.koIPreferenceSet);

        dataPref.setStringPref("sourceFile", gFiles[i].sourceFile);
        dataPref.setStringPref("destinationFile", gFiles[i].destinationFile);
        dataFilesPrefs.appendPref(dataPref);
    }
    
    var versionInfoPref = perlAppPrefSet.getPref('versionInfo');
    versionInfoPref.reset();
    for (i=0; i < gVersionInfo.length; ++i) {
        if (gVersionInfo[i].fieldValue != null) {
            versionInfoPref.setStringPref(gVersionInfo[i].fieldName, gVersionInfo[i].fieldValue);
        }            
    }

    globalPrefSvc.prefs.setPref(perlAppPrefSet.id, perlAppPrefSet);
}    

function apply() {
    savePrefs();
}

function build() {
    if (pdkVersion < 4 && (dialog.scriptname.value.indexOf(' ') != -1) && (dialog.pdkTypeMenu.getAttribute('value') == 'ctrl')) {
        // PerlCtrl cannot build scripts whose path contains spaces
        alertDialog('PerlCtrl cannot build "' + dialog.scriptname.value + '" because it contains a space. Please remove the space in the filename or move the file to a different directory.');
        return;
    }
    
    savePrefs();

    var iprefs = invocation.currentInstancePreferences;

    iprefs.setBooleanPref("use-console", false);
    iprefs.setStringPref("completeCommand", generateCommandString());    
    var error_pref = new Object();
    var error_text = new Object();
    if (!invocation.validate(Components.interfaces.koIInvocation.INVOKE_BUILD, error_pref, error_text)) {
        alert("The invocation is not valid - " + error_text.value);
        return;
    }
    else {
        opener._do_execute_invocation(invocation, Components.interfaces.koIInvocation.INVOKE_BUILD, Components.interfaces.koIDebugger.DBG_STATE_RUNNING);
        opener._setSplitterState("redirect-splitter", 0);

    }

    top.window.close();
}

function cancel() {
    top.window.close();
}

function generateCommandString() {
    var commandstring = getPdkCommand();

    for (var i = 0; i < commandGenerators.length; ++i) {
        var tempCommand = commandGenerators[i]();

        if (tempCommand)
            commandstring += ' ' + tempCommand;
    }
    return commandstring;    
}

function setCommandString() {
    var commandstring = generateCommandString();
    var e = window.frames[0].document.documentElement;
    e.setAttribute("style", "background-color: -moz-Dialog;");
    var commandarea = window.frames[0].document;
    commandarea.open();
    commandarea.write('<FONT FACE="tahoma, arial" STYLE="font-size: 8pt;">');
    commandarea.write(commandstring);
    commandarea.write('</FONT>');
    commandarea.close();
}

