
var myPrefWindow = null;
var startBox;

var invocations = new Array();
var current_invocation_index = 0;
var invoke_type = 0; // what kind of invocation are we displaying?

function SetupDialog() {
    var def_invocation = null;
    if (window.arguments) {
        if (window.arguments[0]) {
            def_invocation = window.arguments[0].invocation;
            invoke_type = window.arguments[0].invoke_type;
        }
    } else {
        invoke_type = Components.interfaces.koIInvocation.INVOKE_DEBUG;
        def_invocation = Components.classes["@activestate.com/koInvocation;1?type=Perl"].createInstance();
    }

    koDoSetOKCancel(doOk, doCancel);
    koCenterWindowOnScreen();

    // Setup a dummy info that is never added to the registry
    var info = Components.classes["@activestate.com/InvocationInformation;1"].
        createInstance(Components.interfaces.koIInvocationInformation);
    info.name = "Unknown file type";
    info.description = info.name
    info.chrome_instance = "chrome://komodo/content/pref/invocations/use-project-invocations.xul";
    var invocation = new Object();
    invocation.info = info
    invocation.component = null;

    invocations[0] = invocation;

    // Populate the rest from the registry, remembering the default
    var svc = Components.classes["@activestate.com/InvocationRegistryService;1"].
        getService(Components.interfaces.koIInvocationRegistryService);
    var enumerator = svc.enumerateInvocations();
    var i = 1; // skip dummy
    while (enumerator.hasMoreElements()) {
        info = enumerator.getNext();
        invocation = new Object();
        invocation.info = info
        if (def_invocation && invocation.info.name == def_invocation.name) {
            invocation.component = def_invocation;
            current_invocation_index = i;
        } else {
            invocation.component = null;
        }
        invocations[invocations.length] = invocation;
        i++;
    }
    FillInvocationPopup();
    ChangeInvocation();
    opener.gOpeningDialog = false;
}

function FillInvocationPopup() {
    var menupopup = document.getElementById('invocation-category-popup');
    while (menupopup.childNodes.length) {
        menupopup.deleteChildAt(0);
    }
    
    for (var i=0;i<invocations.length;i++) {
        var menuitem = document.createElementNS(XUL_NS, 'menuitem');
        menuitem.setAttribute('label', invocations[i].info.description);
        menupopup.appendChild(menuitem);
        if (i==current_invocation_index) {
            document.getElementById('invocation-category').setAttribute('label', invocations[i].info.description);
        }
    }
}

function ChangeInvocation() {
    var name = document.getElementById('invocation-category').getAttribute("label");
    for (var i=0;i<invocations.length;i++) {
        if (invocations[i].info.description == name) {
            var invocation = invocations[i];
            if (myPrefWindow == null) {
                myPrefWindow = new koPrefWindow('debuggingArgs');
                koDoSetOKCancel(doOk, doCancel); // need to reset this after creating
            }
            if( !myPrefWindow )
                throw "failed to create prefwindow";
            var prefSet;
            if (invocation.info.contractid == null) {
                // create a dummy preference set.  Can't use NULL, else the
                // preference window assumes we are using the global one.
                prefSet = Components.classes["@activestate.com/koPreferenceSet;1"].createInstance();
            } else {
                if (invocation.component == null) {
                    try {
                        invocation.component = Components.classes[invocation.info.contractid].createInstance();
                    } catch (e) {
                        logError("Error creating contract ID '" + invocation.info.contractid + "'\n");
                        invocation.info.chrome_instance = "about:blank";
                    }
                }
                // if the invocation has no current preferences, set them as the default.
                if (invocation.component) {
                    if (invocation.component.currentCategoryPreferences == null) {
                        var catOb = new Object();
                        var instOb = new Object();
                        invocation.component.getDefaultPreferences(catOb, instOb);
                        invocation.component.currentCategoryPreferences = catOb.value;
                        invocation.component.currentInstancePreferences = instOb.value;
                        // Update this invocation's default instance preferences
                        var prefs = globalPrefService.prefs;
                        var inv_name = invocation.component.name;
                        if (prefs.hasPref("Invocations")) {
                            var root = prefs.getPref("Invocations");
                            if (root.hasPref(inv_name)) {
                                var storedPrefs = root.getPref(inv_name);
                                invocation.component.currentInstancePreferences.update(storedPrefs);
                            }
                        }
                    }
                    prefSet = invocation.component.currentInstancePreferences;
                }
            }
            // Try and save the current data back to the preference set.
            // ignore failure, as they haven't actually said 'ok' yet.
            if (i != current_invocation_index) {
                if (invocations[current_invocation_index].component)
                    myPrefWindow.onSinglePageOK();
                current_invocation_index = i;
            }
            // Focus the combo - (mainly to work around a bug that *no* widget has focus, and this upsets Linux
            // child panes may override this to their own widget.
            var focusWidget = document.getElementById("invocation-category");
            focusWidget.focus();

            document.getElementById('debuggingArgs').setAttribute('src', invocation.info.chrome_instance);
            myPrefWindow.init(prefSet);
            return;
        }
    }
    // not found - use project one (probably need an "unknown invocation" panel
    document.getElementById('debuggingArgs').setAttribute('src', invocations[0].info.chrome_instance);
}

function _setReturnVar(name, val) {
  if (window.arguments && window.arguments[0])
    window.arguments[0][name]=val;
  return true;
}

function _setResult(res) {
    return _setReturnVar("res", res)
}

function doOk() {
    if (!myPrefWindow.onSinglePageOK())
        return false;
    // get the invocation to validate the preference set.
    var invocation = invocations[current_invocation_index];
    if (invocation.component) {
        var bad_pref_id = new Object();
        var message = new Object();
        var ok = invocation.component.validate(invoke_type, bad_pref_id, message)
        if (!ok) {
            var badWidget = myPrefWindow.findElementWithPreferenceId(bad_pref_id.value);
            if (badWidget)
                badWidget.focus();
            alertDialog(message.value);
            return false;
        }
    }
    _setReturnVar("invocation", invocation.component);
    _setResult("ok");
    return true;
}

function doCancel() { 
  _setResult("cancel");
  return true;
}

function doClose() { 
  doCancel();
  window.close();
}

// Utility functions for the various panels.
function doBrowseForDir(widget_id) {
    if (!widget_id)
        widget_id = "cwd";
    var textField = myPrefWindow._getPrefElementsParent().getElementById(widget_id);
    var dir = BrowseForDir(textField.value);
    if (dir) textField.value = dir;
}

function doBrowseForLanguageFile(widget_id, language) {
    var textField = myPrefWindow._getPrefElementsParent().getElementById(widget_id);
    var picker = dlg_openFileOfLanguage(language, textField.value);
    if (picker) {
        textField.value = picker.file.path;
    }
}

function doBrowseForXMLInputFile(widget_id) {
    if (!widget_id) return;
    var textField = myPrefWindow._getPrefElementsParent().getElementById(widget_id)
    var filters = [['XML Input Files',['*.xml','*.xsl']]];
    var filename = BrowseForFile(textField.value, filters);
    if (filename)
        textField.value = filename;
}

function doBrowseForCommandFile(widget_id) {
    if (!widget_id) return;
    var textField = myPrefWindow._getPrefElementsParent().getElementById(widget_id)

    var infoService = Components.classes["@activestate.com/koInfoService;1"].getService();
    var filters;
    if (infoService.isWindows)
        filters = [['Command Files',['*.exe','*.com', '*.bat', '*.cmd']], ['All Files', ['*.*']]];
    else
        filters = [['All Files', ['*']]];

    var filename = BrowseForFile(textField.value, filters);
    if (filename)
        textField.value = filename;
}


function toggleCGITabs() {
    var usecgi = myPrefWindow._getPrefElementsParent().getElementById("debuggerRunAsCGI");
    if (!usecgi) return;
    var checked = usecgi.getAttribute("checked");
    var t1 = myPrefWindow._getPrefElementsParent().getElementById("cgiEnvironment");
    var t2 = myPrefWindow._getPrefElementsParent().getElementById("cgiInput");
    if (checked=="true") {
        t1.collapsed = false;
        t2.collapsed = false;
    } else {
        t1.collapsed = true;
        t2.collapsed = true;
    }
}
