/* Copyright (c) 2000-2001 ActiveState Tool Corporation.
   See the file LICENSE.txt for licensing information. */

// Constants and global variables
const tag = 'chrome://komodo/content/pref/pref-file.xul';
var globalPrefService = Components.classes["@activestate.com/koPrefService;1"]
            .getService(Components.interfaces.koIPrefService);
var newPref;
var dialog;
var view;
var newHasChanged = false;

var _elementIDs = [
    "fileDefaultNew",
    "defaultGUILanguage"
];

function PrefFile_OnLoad() {
    // set up UI elements
    dialog = {};
    dialog.fileDefaultNew = document.getElementById('fileDefaultNew');
  
    // GUI Builder group box setup
    dialog.list = document.getElementById('defaultGUILanguage');
    dialog.popup = document.getElementById('guiPopup');
    var guiBuilderSvc = Components.classes["@activestate.com/koGuiBuilderService;1"].getService(Components.interfaces.koIGuiBuilderService);
    var ids = new Object();
    var labels = new Object();
    guiBuilderSvc.getLanguages(new Object(), ids, new Object(), labels);
    var item, id, label;
    var selectedItem = null;
    for (var i = 0; i < ids.value.length; i++) {
        item = document.createElement('menuitem');
        id = ids.value[i];
        label = labels.value[i];
        item.setAttribute('data', id);
        item.setAttribute('label', label);
        dialog.popup.appendChild(item);
    }
    item = document.createElement('menuitem');
    item.setAttribute('data', '');  // special case
    item.setAttribute('label', "Ask each time");
    dialog.popup.appendChild(item);
    parent.hPrefWindow.onpageload(tag);
}

function OnPreferencePageLoading(prefset) {
    var newLang = prefset.getStringPref('fileDefaultNew');
    dialog.fileDefaultNew.selection = newLang;

    var defaultGUILanguage = prefset.getStringPref('defaultGUILanguage');
    var items = dialog.popup.childNodes;
    for (var i=0; i < items.length;     i++) {
        if (items[i].getAttribute('data') == defaultGUILanguage) {
            dialog.list.selectedItem = items[i];
            return;
        } 
    }
}

function OnPreferencePageUnloading(prefset) {
    var item = dialog.list.selectedItem;
    prefset.setStringPref('defaultGUILanguage', dialog.list.selectedItem.getAttribute('data'));
    prefset.setStringPref('fileDefaultNew', dialog.fileDefaultNew.selection);
}

