/* Copyright (c) 2000-2001 ActiveState Tool Corporation.
   See the file LICENSE.txt for licensing information. */

//---- globals
var _findingInterps = false;

//---- functions


function PrefPerl_OkCallback(prefset)
{
    var ok = true;
    
    // ensure that the default perl interpreter is valid
    var defaultInterp = prefset.getStringPref("perlDefaultInterpreter");
    if (defaultInterp != "") {
        var koSysUtils = Components.classes["@activestate.com/koSysUtils;1"].
            getService(Components.interfaces.koISysUtils);
        if (! koSysUtils.IsFile(defaultInterp)) {
            parent.opener.alertDialog("No Perl interpreter could be found at '" +
                defaultInterp + "'. You must make another selection for " +
                "the default Perl interpreter.\n");
            ok = false;
            document.getElementById("perlDefaultInterpreter").focus();
        }
    }
    return ok;
}


function PrefPerl_UnSelectInterp()
{
    var tree = document.getElementById("tree-avail-interp-list");
    tree.clearItemSelection();
}


function PrefPerl_SelectInterp()
{
    if (! _findingInterps) {
        // Load the default interpeter textfield with the selection
        var tree = document.getElementById("tree-avail-interp-list");
        var defaultInterp = document.getElementById("perlDefaultInterpreter");
        if (tree.selectedItems.length > 0) {
            var selection = tree.selectedItems[0];
            //          treeitem . treerow  . treecell 
            var value = selection.firstChild.firstChild.getAttribute("label");
            defaultInterp.value = value;
        }
    }
}


function _CreatePerlInterpItem(fname)
{
    var treecell = document.createElementNS(XUL_NS, 'treecell');
    treecell.setAttribute('label', fname);
    var treerow = document.createElementNS(XUL_NS, 'treerow');
    treerow.appendChild(treecell);
    var treeitem = document.createElementNS(XUL_NS, 'treeitem');
    treeitem.appendChild(treerow);
    return treeitem;
}


// Populate the (tree) list of available Perl interpreters on the current
// system.
function PrefPerl_PopulatePerlInterps()
{
    var availInterpList = document.getElementById("avail-interp-list");
    var defaultInterp = document.getElementById("perlDefaultInterpreter");

    // remove any existing items and add a "finding..." one
    _findingInterps = true;
    while (availInterpList.hasChildNodes()) {
        availInterpList.removeChild(availInterpList.childNodes[0]);
    }
    availInterpList.appendChild(_CreatePerlInterpItem(
        "Finding available Perl interpreters..."));
   
    // get a list of installed Perl interpreters
    var sysUtils = Components.classes['@activestate.com/koSysUtils;1'].
        getService(Components.interfaces.koISysUtils);
    var availInterps = new Array();
    availInterps = sysUtils.WhichAll("perl", new Object());

    // populate the tree listing them
    if (availInterps.length == 0) {
        // tell the user no interpreter was found and direct them to
        // ActiveState to get one
        document.getElementById("avail-interp-box").
            setAttribute("collapsed", "true");
        document.getElementById("no-avail-interps-message").
            setAttribute("collapsed", "false");
    } else {
        availInterpList.removeChild(availInterpList.childNodes[0]); // "Finding..."
        for (var i = 0; i < availInterps.length; i++) {
            availInterpList.appendChild(_CreatePerlInterpItem(
                availInterps[i]));
        }
    }
    _findingInterps = false;
}


function PrefPerl_OnLoad()
{
    var tag = 'chrome://komodo/content/pref/pref-perl.xul';
    parent.hPrefWindow.onpageload(tag);
    parent.hPrefWindow.registerOKCallbackFunc(PrefPerl_OkCallback, tag) 

    // find the available Perl interps (but let window load)
    PrefPerl_PopulatePerlInterps();
}


