/* Copyright (c) 2000-2001 ActiveState Tool Corporation.
   See the file LICENSE.txt for licensing information. */

//---- globals
var _findingInterps = false;

//---- functions

/* Functions Related to pref-phpini.xul */
function PrefPhp_OnLoad()  {
    var tag = 'chrome://komodo/content/pref/pref-php.xul';
    parent.hPrefWindow.onpageload(tag);
    parent.hPrefWindow.registerOKCallbackFunc(PrefPhp_OkCallback, tag);
    // find the available PHP interps
    PrefPhp_PopulatePHPInterps();
}

function PrefPhp_OkCallback(prefset)
{
    var ok = true;
    
    // ensure that the default PHP interpreter is valid
    var defaultInterp = prefset.getStringPref("phpDefaultInterpreter");
    if (defaultInterp != "") {
        var koSysUtils = Components.classes["@activestate.com/koSysUtils;1"].
            getService(Components.interfaces.koISysUtils);
        if (! koSysUtils.IsFile(defaultInterp)) {
            parent.opener.alertDialog("No PHP interpreter could be found at '" +
                defaultInterp + "'. You must make another selection for " +
                "the default PHP interpreter.\n");
            ok = false;
            document.getElementById("phpDefaultInterpreter").focus();
        }
    }

    return ok;
}

function PrefPhp_UnSelectInterp()
{
    var tree = document.getElementById("tree-avail-interp-list");
    tree.clearItemSelection();
}


function PrefPhp_SelectInterp()
{
    if (! _findingInterps) {
        // Load the default interpeter textfield with the selection
        var tree = document.getElementById("tree-avail-interp-list");
        var defaultInterp = document.getElementById("phpDefaultInterpreter");
        if (tree.selectedItems.length > 0) {
            var selection = tree.selectedItems[0];
            //          treeitem . treerow  . treecell 
            var value = selection.firstChild.firstChild.getAttribute("label");
            defaultInterp.value = value;
        }
    }
}

// Populate the (tree) list of available PHP interpreters on the current
// system.
function PrefPhp_PopulatePHPInterps()
{
    var availInterpList = document.getElementById("avail-interp-list");

    // remove any existing items and add a "finding..." one
    _findingInterps = true;
    while (availInterpList.hasChildNodes()) {
        availInterpList.removeChild(availInterpList.childNodes[0]);
    }
    availInterpList.appendChild(_CreatePhpInterpItem(
        "Finding available PHP interpreters..."));
   
    // get a list of installed Perl interpreters
    var sysUtils = Components.classes['@activestate.com/koSysUtils;1'].
        getService(Components.interfaces.koISysUtils);
    var availInterps = new Array();
    availInterps = sysUtils.WhichAll("php", new Object()); // Not sure of php is handled here - Needs to examine koSysUtils.py

    // populate the tree listing them
    if (availInterps.length == 0) {
        // tell the user no interpreter was found and direct them to
        // ActiveState to get one
        document.getElementById("avail-interp-box").
            setAttribute("collapsed", "true");
        document.getElementById("no-avail-interps-message").
            setAttribute("collapsed", "false");
    } else {
        availInterpList.removeChild(availInterpList.childNodes[0]); // "Finding..."
        for (var i = 0; i < availInterps.length; i++) {
            availInterpList.appendChild(_CreatePhpInterpItem(
                availInterps[i]));
        }
    }
    _findingInterps = false;
}

function _CreatePhpInterpItem(fname)
{
    var treecell = document.createElementNS(XUL_NS, 'treecell');
    treecell.setAttribute('label', fname);
    var treerow = document.createElementNS(XUL_NS, 'treerow');
    treerow.appendChild(treecell);
    var treeitem = document.createElementNS(XUL_NS, 'treeitem');
    treeitem.appendChild(treerow);
    return treeitem;
}

/* Functions Related to pref-phpini.xul */

function PrefPhpIni_OnLoad()  {
    var tag = 'chrome://komodo/content/pref/pref-phpini.xul';
    parent.initPanel(tag);
    parent.registerOKCallbackFunc(PrefPhpIni_OkCallback, tag);

}

function PrefPhpIni_OkCallback(prefset)
{
    //...
    return true;
}

function loadIniFile() {
    var fpOpen = Components.classes["@mozilla.org/filepicker;1"].
    createInstance(Components.interfaces.nsIFilePicker);
    fpOpen.init(window, "Open File", Components.interfaces.nsIFilePicker.modeGetFolder);
    fpOpen.appendFilters(Components.interfaces.nsIFilePicker.filterAll);
    if (fpOpen.show() == Components.interfaces.nsIFilePicker.returnOK) {
        document.getElementById('phpConfigFile').setAttribute('value', fpOpen.file.path)
    }
}