/* Copyright (c) 2000-2002 ActiveState SRL.
   See the file LICENSE.txt for licensing information. */

// The source code control preferences panel.

//---- globals

// XXX Should _elementIDs include the *other* prefs on this pane as well
//     or is this an obselete bit of code? -- TM
var _elementIDs = ["cvsBackgroundMinutes", "p4BackgroundMinutes", "cvsDiffOptions", "p4DiffOptions",
                   "cvsEnabled", "p4Enabled", "cvsBackgroundEnabled", "p4BackgroundEnabled",
                   "cvsRecursive", "p4Recursive", "diffDisplayStyle"];

var dlg = new Object(); // holds refs to all the required DOM elements

var _cvsSvc = Components.classes["@activestate.com/koCVS;1"].
              getService(Components.interfaces.koICVS);
var _p4Svc = Components.classes["@activestate.com/koP4;1"].
             getService(Components.interfaces.koIP4);


//---- functions for pref-scc.xul

function PrefSCC_OnLoad()
{
    var tag = 'chrome://komodo/content/pref/pref-scc.xul';
    parent.hPrefWindow.onpageload(tag);
    parent.hPrefWindow.registerOKCallbackFunc(PrefSCC_OkCallback, tag); 

    dlg.cvsEnabled = document.getElementById("cvsEnabled");
    dlg.cvsDeck = document.getElementById("cvsDeck");
    dlg.cvsBackgroundCheck = document.getElementById("cvsBackgroundCheck");
    dlg.cvsBackgroundMinutes = document.getElementById("cvsBackgroundMinutes");
    dlg.cvsDiffOptions = document.getElementById("cvsDiffOptions");
    dlg.cvsRecursive = document.getElementById("cvsRecursive");
    dlg.cvsNotFunctional = document.getElementById("cvsNotFunctional");
    dlg.p4Enabled = document.getElementById("p4Enabled");
    dlg.p4Deck = document.getElementById("p4Deck");
    dlg.p4BackgroundCheck = document.getElementById("p4BackgroundCheck");
    dlg.p4BackgroundMinutes = document.getElementById("p4BackgroundMinutes");
    dlg.p4DiffOptions = document.getElementById("p4DiffOptions");
    dlg.p4Recursive = document.getElementById("p4Recursive");
    dlg.p4NotFunctional = document.getElementById("p4NotFunctional");
    dlg.startup = true;
    PrefSCC_UpdateNotFunctionalUI('cvs');
    PrefSCC_UpdateNotFunctionalUI('p4');
    PrefSCC_UpdateEnabledUI('cvs');
    PrefSCC_UpdateEnabledUI('p4');
    dlg.startup = false;
}


function PrefSCC_OkCallback(prefset)
{
    var ok = true;
    
    // Ensure that user settings are valid.
    //XXX Should ensure that "*BackgroundMinutes" are positive non-zero
    //    numbers.

    return ok;
}

function _setElementDisabled(elt, disabled) {
    if (disabled) {
        elt.setAttribute('disabled', true);
    } else {
        if (elt.hasAttribute('disabled')) {
            elt.removeAttribute('disabled');
        }
    }
}

function PrefSCC_UpdateEnabledUI(type)
{
    //dump("PrefSCC_UpdateEnabledUI('"+type+"')\n");
    var disabled = null;
    switch (type) {
    case "cvs":
        disabled = !dlg.cvsEnabled.checked;
        _setElementDisabled(dlg.cvsBackgroundCheck, disabled);
        _setElementDisabled(dlg.cvsDiffOptions, disabled);
        if (!dlg.startup && !disabled 
            && !document.getElementById('cvsBackgroundCheck').checked
            && document.getElementById('cvsSSHWarn').checked) {
            doSCCCheckForSSH();
        }
        break;
    case "p4":
        disabled = !dlg.p4Enabled.checked;
        _setElementDisabled(dlg.p4BackgroundCheck, disabled);
        _setElementDisabled(dlg.p4DiffOptions, disabled);
        break;
    default:
        throw("Unexpected SCC type: '"+type+"'");
    }
    PrefSCC_UpdateBackgroundEnabledUI(type);
}


function PrefSCC_UpdateBackgroundEnabledUI(type)
{
    //dump("PrefSCC_UpdateBackgroundEnabledUI('"+type+"')\n");
    var disabled = null;
    switch (type) {
    case "cvs":
        disabled = !(dlg.cvsBackgroundCheck.checked && dlg.cvsEnabled.checked);
        _setElementDisabled(dlg.cvsBackgroundMinutes, disabled);
        _setElementDisabled(dlg.cvsRecursive, disabled);
        if (!dlg.startup && !disabled 
            && document.getElementById('cvsSSHWarn').checked) {
            doSCCCheckForSSH();
        }
        break;
    case "p4":
        disabled = !(dlg.p4BackgroundCheck.checked && dlg.p4Enabled.checked);
        _setElementDisabled(dlg.p4BackgroundMinutes, disabled);
        _setElementDisabled(dlg.p4Recursive, disabled);
        break;
    default:
        throw("Unexpected SCC type: '"+type+"'");
    }
}


function PrefSCC_UpdateNotFunctionalUI(type)
{
    //dump("PrefSCC_UpdateNotFunctionalUI('"+type+"')\n");
    var reason = null;
    switch (type) {
    case "cvs":
        if (_cvsSvc.isFunctional) {
            _setElementDisabled(dlg.cvsEnabled, false);
            dlg.cvsDeck.setAttribute("index", 0);
        } else {
            _setElementDisabled(dlg.cvsEnabled, true);
            dlg.cvsDeck.setAttribute("index", 1);
            // Describe why CVS is not functional.
            reason = "CVS integration has been disabled in Komodo because " +
                     _cvsSvc.reasonNotFunctional + ". Visit the following " +
                     "site for more information on CVS.";
            while (dlg.cvsNotFunctional.hasChildNodes()) {
                dlg.cvsNotFunctional.removeChild(dlg.cvsNotFunctional.firstChild);
            }
            dlg.cvsNotFunctional.appendChild(document.createTextNode(reason));
        }
        break;
    case "p4":
        if (_p4Svc.isFunctional) {
            _setElementDisabled(dlg.p4Enabled, false);
            dlg.p4Deck.setAttribute("index", 0);
        } else {
            _setElementDisabled(dlg.p4Enabled, true);
            dlg.p4Deck.setAttribute("index", 1);
            // Describe why Perforce is not functional.
            reason = "Perforce integration has been disabled in Komodo because " +
                     _p4Svc.reasonNotFunctional + ". Visit the following " +
                     "site for more information on Perforce.";
            while (dlg.p4NotFunctional.hasChildNodes()) {
                dlg.p4NotFunctional.removeChild(dlg.p4NotFunctional.firstChild);
            }
            dlg.p4NotFunctional.appendChild(document.createTextNode(reason));
        }
        break;
    default:
        throw("Unexpected SCC type: '"+type+"'");
    }
}


function PrefSCC_CheckAgain(type)
{
    var svc = null;
    switch (type) {
    case "cvs":
        svc = _cvsSvc;
        break;
    case "p4":
        svc = _p4Svc;
        break;
    default:
        throw("Unexpected SCC type: '"+type+"'");
    }
    
    var isFunctionalBefore = svc.isFunctional;
    svc.redetermineIfFunctional();
    var isFunctionalAfter = svc.isFunctional;
    if (isFunctionalBefore == isFunctionalAfter) {
        alertDialog("Integration with "+type+" is still disabled because "+svc.reasonNotFunctional+".");
    } else {
        PrefSCC_UpdateNotFunctionalUI(type);
    }
}

function doSCCCheckForSSH() {
    var os = Components.classes["@activestate.com/koOs;1"].getService(Components.interfaces.koIOs);
    var cvsrsh = os.getenv('CVS_RSH');
    var checkSSH = cvsrsh != '';
    if (!checkSSH) return;
    var ret = alertDialog("CVS Warning: The CVS_RSH environment variable is set to '"+cvsrsh+"', "+
                          "and you have CVS Background Status Checking turned on.  "+
                          "Read the Komodo documentation regarding the "+
                          "use of external protocols, such as SSH, with Komodo.  Failure to properly "+
                          "configure CVS may result in process lockups within Komodo.");
}
