/* Copyright (c) 2000-2001 ActiveState Tool Corporation.
   See the file LICENSE.txt for licensing information. */

// start the extension
registeredExtensions[registeredExtensions.length] = new peTemplate();

function peTemplate() {
}

// The following two lines ensure proper inheritance (see Flanagan, p. 144).
peTemplate.prototype.constructor = peTemplate;

peTemplate.prototype.init = function() {
}

peTemplate.prototype.registerCommands = function() {
    extensionManager.registerCommand('cmd_openTemplate', this);
}

peTemplate.prototype.registerEventHandlers = function() {
    extensionManager.addEventHandler(Components.interfaces.koIPart,'ondblclick',this);
    extensionManager.addEventHandler(Components.interfaces.koIPart,'onUpdatePart',this);
}

peTemplate.prototype.registerMenus = function() {
    extensionManager.createMenuItem(Components.interfaces.koIPart,
                                    'Open Template','cmd_openTemplate');
}

peTemplate.prototype.supportsCommand = function(command, part) {
    var view = gFocusedProjectView;
    if (!view) return false;
    //dump("supportsCommand for " + command +'\n');
    switch (command) {
    case 'cmd_openTemplate':
        if (!part)
            part = view.getSelectedPart();
        return (part && part.type == 'template');
    default:
        break;
    }
    return false;
}

peTemplate.prototype.isCommandEnabled = peTemplate.prototype.supportsCommand

peTemplate.prototype.ondblclick = function(part,event) {
    if (part.type != 'template') return;
    this.openTemplate(part)
}

peTemplate.prototype.doCommand = function(command) {
    switch (command) {
    case 'cmd_openTemplate':
        var items = gFocusedProjectView.getSelectedItems();
        for (var i = 0; i < items.length; i++) {
            if (items[i].type == 'template') this.openTemplate(items[i]);
        }        
        break;
    default:
        break;
    }    
}

peTemplate.prototype.openTemplate= function(item)
{
    var template;
    /* We need to create the templates from the data stored in the part */
    if (item.part.value == 'Blank') {
        template = Components.classes["@activestate.com/koBlankLanguageTemplate;1"].createInstance();
        template.language = item.part.getStringAttribute('language');
    } else {
        template = Components.classes["@activestate.com/koFileTemplate;1"].createInstance();
        template.fileURI = item.part.value;
    }
    ///* cache them in the wrapped part XXX */
    //item.template = template;
    //}
    if (item.part.value == 'Blank') {
        return viewManager.doFileNew(template.language);
    } else {
        return viewManager.doNewFileTemplate(template);
    }
}

peTemplate.prototype.onUpdatePart = function(part,event)
{
    if (part.type == 'template') {
        part.renameable = true;
        part.iconstyle['template'] = 1;
    }
}

function AddTemplateToToolbox(template) {
    var templateName, templateValue, templateLanguage, filetemplate, blanktemplate;
    var part = Components.classes['@activestate.com/koPart?type=template;1'].createInstance(Components.interfaces.koIPart_template);
    part.type = 'template';
    try {
        filetemplate = template.QueryInterface(Components.interfaces.koIFileTemplate);
    } catch (e) {
        try {
            blanktemplate = template.QueryInterface(Components.interfaces.koIBlankLanguageTemplate);
        } catch (e) {
            alertDialog("Don't know what kind of template this is!");
            logError("Don't know what kind of template this is!");
            return
        }
    }
    if (filetemplate) {
        templateName = makeLeafName(filetemplate.fileURI);
        templateValue = filetemplate.fileURI;
        var languageRegistry = Components.classes["@activestate.com/koLanguageRegistryService;1"].getService(Components.interfaces.koILanguageRegistryService);
        templateLanguage = languageRegistry.suggestLanguageForFile(templateName);
    } else {
        templateName = templateValue + ' Template';
        templateValue = 'Blank';
        templateLanguage = templateValue;
    }
    part.setStringAttribute('name', templateName);
    part.setStringAttribute('language', templateLanguage);
    part.value = templateValue;
    // this specificaly adds to the toolbox!
    toolboxMgr.addItem(part);
}


