/* Copyright (c) 2000-2001 ActiveState Tool Corporation.
   See the file LICENSE.txt for licensing information. */

// start the extension
registeredExtensions[registeredExtensions.length] = new peURL();

function peURL() {
}

// The following two lines ensure proper inheritance (see Flanagan, p. 144).
peURL.prototype.constructor = peURL;

peURL.prototype.init = function() {
}

peURL.prototype.registerCommands = function() {
    extensionManager.registerCommand('cmd_openSpecifiedURL', this);
}

peURL.prototype.registerEventHandlers = function() {
    extensionManager.addEventHandler(Components.interfaces.koIPart_URL,'ondblclick',this);
    extensionManager.addEventHandler(Components.interfaces.koIPart_URL, 'onUpdatePart',this);
}

peURL.prototype.registerMenus = function() {
    extensionManager.createMenuItem(Components.interfaces.koIPart_URL, 
                                    'Open URL','cmd_openSpecifiedURL');
}

peURL.prototype.ondblclick = function(part,event) {
    if (part.type != 'URL') return;
    this.openURL(part)
}

peURL.prototype.supportsCommand = function(command, part) {
    var items = gFocusedProjectView.getSelectedItems();
    if (items.length > 1) return false;
    
    var view = gFocusedProjectView;
    if (!view) return false;
    //dump("supportsCommand for " + command +'\n');
    switch (command) {
    case 'cmd_openSpecifiedURL':
        return true;
    default:
        break;
    }
    return false;
}

peURL.prototype.isCommandEnabled = peURL.prototype.supportsCommand;

peURL.prototype.doCommand = function(command) {
    var view = gFocusedProjectView;
    var part = view.getSelectedPart();
    switch (command) {
    case 'cmd_openSpecifiedURL':
        this.openURL(part);
        break;
    default:
        break;
    }    
}

peURL.prototype.openURL= function(item) {
    var part = item.part;
    //dump("part = " + part + " type = " + typeof(part) +'\n');
    var URL = part.value;
    //dump("URL = " + URL + ' type = ' + typeof(URL) +'\n');
    try {
        OpenUrlInDefaultBrowser(URL);
    } catch (e) {
        logError(e);
    }
}

peURL.prototype.onUpdatePart = function(part,event)
{
    if (part.type == 'URL') {
        part.renameable = true;
        part.iconstyle['URL'] = 1;
    }
}

function AddURL(URLtext) {
    try {
        dump("in AddURL "+URLtext+"\n");
        var URL = Components.classes['@activestate.com/koPart?type=URL;1'].createInstance(Components.interfaces.koIPart_URL);
        URL.type = 'URL';
        var name = URLtext;
        var value = URLtext;
        if (URLtext.search("\n")) {
            var s = URLtext.split("\n");
            name = typeof(s[1])!='undefined'?s[1]:s[0];
            value = s[0];
        }
        URL.setStringAttribute('name', name);
        URL.value = value;
        gFocusedProjectView.manager.addItem(URL);
        //dump("leaving AddURL\n");
    } catch (e) {
        logError(e);
    }
}

