/* Copyright (c) 2000-2001 ActiveState Tool Corporation.
   See the file LICENSE.txt for licensing information. */

// fake out a viewManager for the scintilla widget
var viewManager = new ScintillaViewManager();

function dumpWidget(widget) {
    for(x in widget) {
        try { dump("  " + x + ": " + widget[x] + "\n"); } catch(e) {}
    }
}

var keyPressedObserver = null;
var keywords = "for break continue if else elseif endif do while return switch case function class";

function onTestLoad() {
    var scimoz_widget = document.getElementById('scimoz');
    scimoz_widget.init();
    langItemsController = new LanguageItemsController();
    scimoz_widget.controllers.appendController(langItemsController);
    scimoz_widget.viewManager = viewManager;
    dump('** Added a Scintilla controller to the Scintilla widget! **\n');

    //scimoz_widget.ISciMoz.codePage = 65001; // Unicode

    var marginWidth = 16;
    //scimoz_widget.ISciMoz.setMarginWidthN (1, marginWidth);
    //scimoz_widget.ISciMoz.setMarginWidthN(2, marginWidth);  
    //scimoz_widget.ISciMoz.docPointer = scimoz_widget.ISciMoz.createDocument();
    try {
        scimoz_widget.ISciMoz.hookEvents( new eventist() );
        //scimoz_widget.ISciMoz.lexer = Components.interfaces.ISciMoz.SCLEX_HTML
        //scimoz_widget.ISciMoz.setKeyWords(4, keywords)
    }
    catch(e) {
        dump("Oops. Initialization failed because " + e + "\n");
    }

    scimoz_widget.focus();
    // document.getElementById('scimoz2').init();
    dump('Focus is ' + document.commandDispatcher.focusedElement + '\n')

    koRequestUpdateCommands('buffer-visible');

    dump("Let's see what key_backSmart is: " + document.getElementById("key_backSmart") + "\n");
    
  var workDeck = document.getElementById('workspace-deck');
  workDeck.setAttribute('index', '1');
  
  // set a default style
  //scimoz_widget.ISciMoz.styleBits = 7; //html stylebits
  //set_style(scimoz_widget.ISciMoz, 32, 'verdana', RGB(0,0,0), RGB(255,255,255),0,0,12,0);
  // php styles
  /*set_style(scimoz_widget.ISciMoz, 118, 'verdana', RGB(0,0,0), RGB(255,255,255),0,0,14,0);
  set_style(scimoz_widget.ISciMoz, 119, 'verdana', RGB(0,0,0), RGB(0,0,255),0,0,14,0);
  set_style(scimoz_widget.ISciMoz, 120, 'verdana', RGB(0,0,0), RGB(255,0,0),0,0,14,0);
  set_style(scimoz_widget.ISciMoz, 121, 'verdana', RGB(0,0,0), RGB(0,255,0),0,0,14,0);
  set_style(scimoz_widget.ISciMoz, 122, 'verdana', RGB(0,0,0), RGB(0,0,190),0,0,14,0);
  set_style(scimoz_widget.ISciMoz, 123, 'verdana', RGB(0,0,0), RGB(0,190,0),0,0,14,0);
  set_style(scimoz_widget.ISciMoz, 124, 'verdana', RGB(0,0,0), RGB(190,0,0),0,0,14,0);
  set_style(scimoz_widget.ISciMoz, 125, 'verdana', RGB(0,0,0), RGB(100,255,255),0,0,14,0);
  set_style(scimoz_widget.ISciMoz, 126, 'verdana', RGB(0,0,0), RGB(255,255,100),0,0,14,0);
    */
}

function RGB(r,g,b) {
    return r+g*256+b*256*256;
}
function set_style(scimoz, style, font, fore, back, italic, bold, size, eol) {
    scimoz.styleSetFont(style, font);
    scimoz.styleSetFore(style, fore);
    scimoz.styleSetBack(style, back);
    scimoz.styleSetItalic(style, italic);
    scimoz.styleSetBold(style, bold);
    scimoz.styleSetSize(style, size);
    scimoz.styleSetEOLFilled(style, eol);
}

var bContextMenuActive = false;

function contextMenu_onCreate()
{
    bContextMenuActive = true;
}

function contextMenu_onDestroy()
{
    bContextMenuActive = false;
}
function fillInTestTooltip ( tipElement )
{
  // The tooltip will cancel the menu!!!
//  if (bContextMenuActive) {
//    dump("Not displaying tooltip as a context menu is active!\n");
//    return false;
//  }
  var cmdNode = document.getElementById("cmd_undo");
  dump("cmd_undo is " + cmdNode + "\n");

  var textNode = document.getElementById("TOOLTIP-tooltipText");
  if ( textNode ) {  
    textNode.setAttribute('value', 'Ohhh, look!');
    return true;
  }
  dump("** can't find tooltipText element **\n");
  return false;
}

function LanguageItemsController () {
    logDebug("LanguageItemsController starting up...");
}

LanguageItemsController.prototype = {
    supportsCommand: function(command) {
        switch(command) {
            case "cmd_backSmart":
            logDebug("cmd_backSmart is supported");
            return true;
        }
        return true;
    },
    isCommandEnabled: function(command) {
        return true;
    },
    doCommand: function(command) {
        dump("LanguageItemsController.doCommand("+command+")\n");
        switch(command) {
            case "cmd_backSmart":
            dump('Focus is ' + document.commandDispatcher.focusedElement.id + '\n')
            var scimoz = document.commandDispatcher.focusedElement.ISciMoz;
            scimoz.deleteBack()
            dump("Focused scimoz: " + scimoz + "\n");
            return true;
        }

        return false;
    },
    onEvent: function(event) {

    }
}

var completions = "about above acne add after agat ahhh apple beyond charlie dog edward freak green hat iglue jack keep loony money none open people quick";

function eventist() {
    this._lastchar = 0;
}
eventist.prototype = {
  onStyleNeeded: function(position) {
    dump("onStyleNeeded " + position);
  },
  onCharAdded: function(ch) { 
      this._lastchar = ch;
    dump("onCharAdded " + ch + "\n");
  },
  onSavePointReached: function() { 
    dump("onSavePointReached" + "\n");
  },
  onSavePointLeft: function() { 
    dump("onSavePointLeft" + "\n");
  },
  onModifyAttemptRO: function() { 
    dump("onModifyAttemptRO" + "\n");
  },
  onKey: function(ch, modifiers) { 
    dump("onKey " + ch + ":" + modifiers + "\n");
  },
  onDoubleClick: function() { 
    dump("onDoubleClick" + "\n");
  },
  onUpdateUI: function() { 
    dump("onUpdateUI" + "\n");
    if (this._lastchar) {
      var scimoz_widget = document.getElementById('scimoz');
      var scimoz = scimoz_widget.ISciMoz;
      if (!scimoz.autoCActive() && this._lastchar==46) { // 46=='.'
          scimoz.autoCShow(0, completions);
      }
    }
    koRequestUpdateCommands('buffer-visible');
    koRequestUpdateCommands('buffer-focus');
  },
  onModified: function(position, modificationType, text, length,
		       linesAdded, line, foldLevelNow, foldLevelPrev) {
    dump("onModified " + position + ":" + modificationType + "\n");
  },
  onMacroRecord: function(message, wParam, lparam) { 
    dump("onMacroRecord " + message + ":" + wParam + ":" + lparam + "\n");
  },
  onMarginClick: function(modifiers, position, margin) {
    dump("onMarginClick " + modifiers + ":" + position + ":" + margin + "\n");
  },
  onNeedShown: function(position, length) {
    dump("onNeedShown " + position + ":" + length + "\n");
  },
  onPosChanged: function(position) {
    dump("onPosChanged " + position + "\n");
  },
  // nsISupports interface
  QueryInterface: function(iid) {
    var ISCIMOZEVENTS_IID = 
    Components.ID("{1b7577c0-ba94-42b6-879d-c4783b9e3c76}");
    if (!iid.equals(Components.interfaces.nsISupports) &&
	!iid.equals(Components.interfaces.ISciMozEvents))
    throw Components.results.NS_ERROR_NO_INTERFACE;
    return this;
  }
}

// dummy up some stuff to fake out the scintilla widget keypress handler
function ScintillaController() {
}

ScintillaController.prototype.keyPressed = function(ch) {
}

function ScintillaView() {
    	this.py_inst = new ScintillaController();
}

function ScintillaViewManager() {
  this.view = new ScintillaView();
}

ScintillaViewManager.prototype.getCurrentView = function () {
  return this.view;
}



