

// support for drag and drop of tabs
var dragService = Components.classes["@mozilla.org/widget/dragservice;1"].
                        getService(Components.interfaces.nsIDragService);
var trans = Components.classes["@mozilla.org/widget/transferable;1"].
                        createInstance(Components.interfaces.nsITransferable);

function simpleHash() {
    this.length = 0;
    this._hash = [];
}
simpleHash.prototype.constructor = simpleHash;
simpleHash.prototype.add = function(key, value) {
    if (!this._hash[key]) this.length++;
    this._hash[key]=value;
}
simpleHash.prototype.remove = function(key) {
    if (this._hash[key]) {
        delete this._hash[key];
        this.length--;
    }
}
simpleHash.prototype.get = function(key) {
    if (this._hash[key]) {
        return this._hash[key];
    }
    return null;
}

function openTen() {
    for (var i =0 ; i<10; i++) {
        gContentManager.newtab('textbox');
    }
}


var gContentManager = null;
function contentManagerOnLoad() {
    // only one boxmanager should exist
    gContentManager = new boxManager();
}

function boxManager() {
    this.vcontainer = document.getElementById("vbox-tabparent");
    this.hcontainer = document.getElementById("hbox-tabparent");
    this.tabBoxCounter = 0;
    this.tabBoxes = new simpleHash();
    this.tabcounter = 0;
    
    // create the initial tabbox
    this.currentTabBox = this.newtabbox(this.hcontainer);
}

boxManager.prototype.constructor = boxManager;

boxManager.prototype.newtabbox = function(parent, vertical) {
    // create the new box with a unique id
    this.tabBoxCounter++;
    var tabbox_id = "tabbox_"+this.tabBoxCounter;
    var newtabbox = document.createElement('tabdeckcontrol');
    newtabbox.setAttribute("flex", '1');
    newtabbox.setAttribute("id", tabbox_id);
    newtabbox.setAttribute("style","min-width: 1px;");

    // add the splitter
    if (typeof(vertical) != "undefined") {
        var splitter = document.createElement('splitter')
        if (vertical) {
            splitter.setAttribute('orient', 'vertical');
        } else {
            splitter.setAttribute('orient', 'horizontal');
        }        
        var grippy = document.createElement('grippy')
        grippy.setAttribute('class', "sidebar-splitter-grippy");
        splitter.appendChild(grippy);
        parent.appendChild(splitter);
    }
    
    // add to the dom    
    parent.appendChild(newtabbox);
    
    // save reference to new box    
    this.tabBoxes.add(tabbox_id, newtabbox);

    newtabbox.boxmanager = this;
    //koDumpDOM(this.vcontainer);
    return newtabbox;
}

boxManager.prototype.killtabbox = function(tabbox) {
    // don't delete the last box
    if (this.tabBoxes.length < 2) return false;
    //if (this.currentTabBox == tabbox) {
        //set the first tabbox to current
    //}
    var splitter = null;
    var newFirstBox = null;
    var boxparent = tabbox.parentNode;
    var splitterparent = boxparent;
    if (tabbox == this.hcontainer.firstChild) {
        splitter = tabbox.nextSibling;
        if (!splitter) { // ok, no windows to the right, must be below
            splitter = this.hcontainer.nextSibling;
            splitterparent = splitter.parentNode;
            newFirstBox = splitter.nextSibling;
            if (!splitter || !newFirstBox) { // what the hell?
                dump("something's realy messed up in the world of DOM\n");
                return false;
            }
        }
    } else {
        splitter = tabbox.previousSibling;
    }
    dump("killing the tabbox "+tabbox.id+"\n");
    //koDumpDOM(this.vcontainer,0);
    boxparent.removeChild(tabbox);
    splitterparent.removeChild(splitter);
    this.tabBoxes.remove(tabbox.id);
    if (newFirstBox) { // we have to move the entire tab window
        this.hcontainer.insertBefore(newFirstBox,null);
    }
    this.currentTabBox = this.hcontainer.firstChild; // always the first tabbox created
    this.currentTabBox.focus();
    //koDumpDOM(this.vcontainer,0);
    return true;
}

boxManager.prototype.setCurrent = function(tabbox) {
    this.currentTabBox = tabbox;
}

boxManager.prototype.newtab = function(type) {
    this.tabcounter++;
    var name = "tab_"+this.tabcounter;
    this.openTab(type,name,name);
}

boxManager.prototype.openTab = function(type, leafname, filename) {
    switch (type) {
    case "scintilla":
        var element = document.createElement('scintilla');
        this.currentTabBox.appendTab(filename,leafname,element);
        break;
    case "textbox":
        var element = document.createElement('textbox');
        element.setAttribute("value","test");
        this.currentTabBox.appendTab(filename,leafname,element);
        break;
    case "browser":
        var element = document.createElement('browser');
        element.setAttribute("src","http://www.activestate.com/");
        this.currentTabBox.appendTab(filename,leafname,element);
        break;
    default:
        throw Components.results.NS_ERROR_UNEXPECTED;
    }
}

boxManager.prototype.move_tab = function(this_tab_id, direction) {
    this.currentTabBox.moveTab(this_tab_id, direction);
}

boxManager.prototype.make_splitter = function(this_tab_id, vertical) {
    // split a tab into a new tabbox
    
    // get the current tab information and panel
    var tabbox = this.currentTabBox;
    var tab = tabbox.getTabById(this_tab_id);
    if (!tab) { alert ("couldn't find node " + this_tab_id); }
    var panel = tabbox.getTabPanelById(this_tab_id);
    if (!panel) { alert ("couldn't find node " + this_tab_id+'-content'); }

    tab.setAttribute('tornoff', "1");

    // XXX fix this    
    var original_tabs = tab.parentNode;
    var original_tabpanels = panel.parentNode;
    tab.setAttribute('original_tabbox', tabbox.id);

    // create the new tabManager
    // first, where to put it in the DOM
    var parent= tabbox.parentNode;
    if (!vertical) { parent = parent.parentNode; };
    dump("putting new tabs in "+parent.id+"\n");
    
    var new_tabbox = this.newtabbox(parent,vertical);
    if (tab.getAttribute('selected') == 'true') tabbox.selectSibling();
    this.currentTabBox = new_tabbox;
    this.currentTabBox.addTab(tab,panel);
}

boxManager.prototype.return_to = function(this_tab_id) {
    // this moves a tab back to it's original tabbox (where it was first created)
    // if that tabbox no longer exists, it reverts to the primary tabbox
    var tabbox = this.currentTabBox;
    var tab = tabbox.getTabById(this_tab_id);
    if (!tab) { alert ("couldn't find node " + this_tab_id); }
    var panel = tabbox.getTabPanelById(this_tab_id);
    if (!panel) { alert ("couldn't find node " + this_tab_id+'-content'); }
    
    var original_tabbox = this.tabBoxes.get(tab.getAttribute('original_tabbox'));
    if (!original_tabbox) original_tabbox = this.hcontainer.firstChild;
    
    original_tabbox.addTab(tab,panel);
    
    tab.removeAttribute('tornoff');

    this.currentTabBox = original_tabbox;
    this.currentTabBox.focus();
    dump("tabbox "+tabbox.id+" tabs "+tabbox.tabContainer.childNodes.length+"\n");
    if (tabbox.tabContainer.childNodes.length==0) {
        // no more tabs, lets remove ourselves.
        this.killtabbox(tabbox);
    } else {
        // set some tab to current
        tabbox.selectSibling();
    }
}

boxManager.prototype.adjust_tab_popup = function(menu, tab_id) {
    // modify the popup acording to where the tab is positioned
    var tabbox = this.currentTabBox;
    var tab = tabbox.getTabById(tab_id);
    var menuitem;
    menuitem = document.getElementById('rejoin_menuitem');
    if (tab.getAttribute('original_tabbox') != tab.getAttribute('current_tabbox')) {
        addStyle(menuitem, 'display', 'block');
    } else {
        addStyle(menuitem, 'display', 'none');
    }
    menuitem = document.getElementById('move_tab_up');
    if (tab.previousSibling) {
        addStyle(menuitem, 'display', 'block');
    } else {
        addStyle(menuitem, 'display', 'none');
    }        
    menuitem = document.getElementById('move_tab_down');
    if (tab.nextSibling) {
        addStyle(menuitem, 'display', 'block');
    } else {
        addStyle(menuitem, 'display', 'none');
    }        
    if (tab.parentNode.childNodes.length > 1) {
        addStyle(document.getElementById('new_vertical_tabgroup'), 'display', 'block');
        addStyle(document.getElementById('new_horizontal_tabgroup'), 'display', 'block');
    } else {
        addStyle(document.getElementById('new_vertical_tabgroup'), 'display', 'none');
        addStyle(document.getElementById('new_horizontal_tabgroup'), 'display', 'none');
    }        
}


boxManager.prototype.tearoff = function(this_tab_id){
    // create a new window to receive the panel
    var tabbox = this.currentTabBox;
    var tab = tabbox.getTabById(this_tab_id);
    var panel = tabbox.getTabPanelById(this_tab_id);
    // if we're tearing off the currently selected tab, select a new one first
    if (tab.getAttribute('selected') == "true") tabbox.selectSibling();

    window.openDialog('chrome://komodo/content/test/tabs/tornoff.xul',
                          'tornoff'+this_tab_id, 'all', tabbox, tab, panel);
}

boxManager.prototype.registerChild = function(child, id)
{
    var tabbox = this.currentTabBox;
    
    // get the tab and panel, send the panel to the window, remove the tab
    // the window already has  the tab
    var tab = tabbox.getTabById(id);
    var panel = tabbox.getTabPanelById(id);
    panel.setAttribute("flex",1);
    child.appendChild(panel);
    tabbox.tabContainer.removeChild(tab);
}

boxManager.prototype.getTabboxFromTabId = function(tab_id)
{
    dump("trying to find "+tab_id+"\n");
    var tab = document.getElementById(tab_id);
    if (!tab) return null;
    var tabbox_id = tab.getAttribute("current_tabbox");
    return this.tabBoxes.get(tabbox_id);
}
