/* Copyright (c) 2000-2001 ActiveState Tool Corporation.
   See the file LICENSE.txt for licensing information. */

/* A bunch of test functions for Komodo.
 */

//---- globals - don't create too much, as this is executed in the release build too!

var pdhUtil;
var timerEvent;

function getPythonProfilerService() {
    return Components.classes["@activestate.com/koPythonProfiler;1"].getService();
}

function getStopwatchService() {
    return Components.classes['@activestate.com/koStopwatch;1'].
                getService(Components.interfaces.koIStopwatch);
}

function getFileLoggingService() {
    return Components.classes['@activestate.com/koFileLoggingService;1'].
                getService(Components.interfaces.koIFileLoggingService);
}
    
//---- Leak stuff

function gc_setflag() {
  var g = Components.classes['@activestate.com/koPythonGarbage;1'].getService(Components.interfaces.koIPythonGarbage);
  var defGCFlags = "gc.DEBUG_COLLECTABLE | gc.DEBUG_UNCOLLECTABLE | gc.DEBUG_INSTANCES | gc.DEBUG_OBJECTS";
  var flags = promptDialog("enter debug flags for gc module", defGCFlags);
  if (flags) g.gcDebugFlags(flags);
}

function gc_collect() {
  var g = Components.classes['@activestate.com/koPythonGarbage;1'].getService(Components.interfaces.koIPythonGarbage);
  g.gcCollect();
}

function reference_dump() {
  var g = Components.classes['@activestate.com/koPythonGarbage;1'].getService(Components.interfaces.koIPythonGarbage);
  g.printRefCounts(100);
}

function reference_dump_tracked() {
  var g = Components.classes['@activestate.com/koPythonGarbage;1'].getService(Components.interfaces.koIPythonGarbage);
  g.printTrackedRefCounts(100);
}

function reference_reset_tracked() {
  var g = Components.classes['@activestate.com/koPythonGarbage;1'].getService(Components.interfaces.koIPythonGarbage);
  g.resetTrackedRefCounts();
}

function doBloat(new_bloat) {
    var about = "about:bloat";
    if (new_bloat) about = about+"?new";
    var b = document.getElementById("redirect-blank");
    var flags = nsIWebNavigation.LOAD_FLAGS_BYPASS_PROXY | nsIWebNavigation.LOAD_FLAGS_BYPASS_CACHE;
    if (b) {
        b.webNavigation.loadURI(about, flags);
    }
}

function _startEditorWrapperProfile() {
    _openFilePS = Components.classes["@activestate.com/koPythonProfiler;1"].getService();
    _openFilePS.addClasses("koEditorWrapper");
}

function _endEditorWrapperProfile() {
    _openFilePS.dumpToFile("pyProfiler.txt","cumulative");
    _openFilePS.resetStats();
}

//---- The old test suite (don't know if works)

function Test_RunOldSuite() {
  var registry = Components.classes["@activestate.com/koTestRegistry;1"].getService(Components.interfaces.koITestRegistry);
  registry.registerComponent('test1');
  registry.registerComponent('test2');

  //  dyntest = registry.registerComponent('dyntest');
  //  var testcom=loadPythonModule( "testable" );
  //  testcom.method("setup", [document, window]);
   
  registry.registerComponent('multitest1');
  registry.registerComponent('koFileSpec');
  registry.registerComponent('koLanguageRegistryService');
  registry.registerComponent('koLanguage');

  var testHarness = Components.classes["@activestate.com/koTestHarness;1"].getService(Components.interfaces.koITestHarness);
  testHarness.init("tests.log", "tests.failures");
  var numTestsRun = new Object();
  var numTestsFailed = new Object();
  var retval = testHarness.run(numTestsRun, numTestsFailed);
  var x = Components.classes['@activestate.com/koLocalFile;1'].createInstance(Components.interfaces.koILocalFile);
  x.init("tests.failures", "r");
  var b = '';
  while (true) {
    var z = x.read(200);
    if (!z) break;
    b = b + z;
  }
  if (retval == 0) {
    alert ("Passed all " + numTestsRun.value + " tests!");
  } else if (retval == -1) {
    alert ("Fatal Failure!\nError Log:\n"+b);
  } else {
    alert ("Ran " + numTestsRun.value + " tests and failed " +   numTestsFailed.value + " of them.\nError Log:\n" + b);
  }
}



//---- other test stuff

function Test_OpenUniqueWindow() {
  openWindowUniqueInstance(
    "chrome://komodo/content/test/test_openuniquewindow.xul",
    "komodo_test_openuniquewindow",
    "chrome,all,resizable,scrollbars,dependent=true,dialog=no",
    "komodo_test_openuniquewindow"
  );
}


function _OpenWindowByType( inType, uri )
{
    var windowManager = Components.classes['@mozilla.org/rdf/datasource;1?name=window-mediator'].getService();
    var windowManagerInterface = windowManager.QueryInterface( Components.interfaces.nsIWindowMediator);
    var topWindow = windowManagerInterface.getMostRecentWindow( inType );
  
    if (topWindow) {
        topWindow.focus();
    } else {
        window.open(uri, "_blank", "chrome,menubar,toolbar,resizable,scrollbars");
    }
}

function Test_OpenJavaScriptConsole()
{
    _OpenWindowByType("global:console", "chrome://global/content/console.xul");
}


function Test_DumpFoldInfo()
{
    // Dump lexer fold information for the current file to stdout.
    view = getFocusedViewManager().getCurrentView();
    if (view == null) {
        dump("Cannot dump fold information: there is no current file\n");
        return;
    }
    var sm = view._scimoz;

    dump("-----------------------------------------------------------------\n");
    dump("Dump Fold Information for: " + view.leafName + "\n");
    dump("-----------------------------------------------------------------\n");
    dump("lineNum/ISciMoz.getFoldLevel(lineNum)&SC_FOLDLEVELNUMBERMASK/line\n");
    dump(" note: I don't know how to dump to HEX in JS (JS sucks)\n");
    dump("-----------------------------------------------------------------\n");
    for (var lineNum = 0; lineNum < sm.lineFromPosition(sm.length); lineNum++) {
        // get the line content
        var lineObj = new Object();
        var lineLen = sm.getLine(lineNum, lineObj);
        var line = lineObj.value.substring(0, lineLen);

        // get fold level information
        var foldLevel = sm.getFoldLevel(lineNum);
        foldLevel &= sm.SC_FOLDLEVELNUMBERMASK;
        
        // print out the information
        dump((lineNum+1) + ": " + foldLevel + ": " + line);
    }
    dump("-----------------------------------------------------------------\n");
}


function _koGetDOMString(node, level) {
  if (level == undefined) {
    level = 0
  }
  
  var s = _repeatStr(" ", 2*level) + "<" + node.nodeName + "\n";
  var i;
  for (i = 0; i < node.attributes.length; i++) {
    s = s + _repeatStr(" ", (2*level) + 4) + node.attributes[i].nodeName + "=\"" + node.attributes[i].nodeValue + "\"\n";
  }
  if (node.childNodes.length == 0) {
    s = s + _repeatStr(" ", (2*level)) + "/>\n";
  } else {
    s = s + _repeatStr(" ", (2*level)) + ">\n";
    for (i = 0; i < node.childNodes.length; i++) {
      s = s + _koGetDOMString(node.childNodes[i], level + 1);
    }
    s = s + _repeatStr(" ", 2*level) + "</" + node.nodeName + ">\n";
  }
  return s;
}
    

function Test_DumpDOMtoScintilla(element_id) {
  var x = Components.classes['@activestate.com/koLocalFile;1'].createInstance(Components.interfaces.koILocalFile);
  var filename = "c:\\tmp\\validate_komodo_xul.xml";
  x.init(filename, "w");
  x.puts(_koGetDOMString(element_id));
  x.close();
  viewManager.doFileOpen(filename);
}

function Test_PythonProfilerAddClasses() {
  var classes = promptDialog("Enter class or class.function names", "");
  var ps = getPythonProfilerService();
  if (classes == "*")
      ps.addAllClasses();
  else
      ps.addClasses(classes);
}

function Test_PythonProfilerDumpFile() {
  var filename = promptDialog("Enter dump filename", "pyProfiler.txt");
  var ps = getPythonProfilerService();
  ps.dumpFile(filename);
}



//---- New test suite stuff
// Convetions:
//  - Each independent test is a function that named: "TestSuite_*".
//  - Each test either returns "ok", "skipped" or "failed".
//  - It would be nice if every test printed:
//       <this is what I am doing> ... <result string>
//    and that is it. This might not be appropriate for all tests though.
//

function TestSuite_RunAllTests()
{
    for (obj in window) {
        if (typeof window[obj] == "function" && obj.match(/^TestSuite_/)
            && !obj.match(/^TestSuite_RunAllTests/)
            && !obj.match(/.*_Interactive$/))
        {
            window[obj]();
        }
    }
}

/////////////////////////////////////////////////////////////////////////////////////////////////
var testDirectory = null;
var testNumFiles = 50;
var _openFileTest;
var _openFileTestCounter;
var _openFileGC;
var startMemoryUsage;
function TestSuite_OpenFileSpeed_Interactive()
{
    var dir = BrowseForDir(testDirectory);
    if (!dir) {
        alertdialog("You must pick a test directory!");
        return false;
    }
    var got = promptDialog("How many files would you like to load?", testNumFiles, "OK", "Cancel");
    if (!got) {
        return false;
    }
    gc_setflag();
    testNumFiles = parseInt(got, 10)
    testDirectory = dir;
    timerEvent = 'file-open-close';
    return TestSuite_OpenFileSpeed(null);
}

function _start_OpenFile_Test(dir) {
    if (typeof(dir) != "undefined" && dir) {
        testDirectory = dir;
    }
    if (!testDirectory) {
        dump("OpenFileSpeed: No test directory set\n");
        return false;
    }
    
    // initialize everything
    var stopwatch = getStopwatchService();

    pdhUtil = Components.classes["@activestate.com/koWin32PDHUtil;1"]
              .getService(Components.interfaces.koIWin32PDHUtil);
    
    // empty memory first
    var _openFileGC = Components.classes['@activestate.com/koPythonGarbage;1'].getService(Components.interfaces.koIPythonGarbage);
    _openFileGC.gcCollect();

    // retreive the file list
    _openFileTest = _getFileList(testDirectory);

    // setup profiler
    var openFilePS = getPythonProfilerService();
    openFilePS.resetStats();
    openFilePS.addClasses("koEditorWrapper");

    dump("OpenFileSpeed: starting at "+testDirectory+"\n");
    startMemoryUsage = pdhUtil.GetPerformanceAttributesForCurrentProcess("Process", "Private Bytes");
    stopwatch.startTimerFor(timerEvent);
    return true;
}

function TestSuite_OpenFileSpeed(dir) {
    _start_OpenFile_Test(dir);
    // open files
    for (var i=0;i<_openFileTest.length;i++) {
        viewManager.doFileOpen(_openFileTest[i]);
    }
    _finishOpenFile_Test();
}

function _finishOpenFile_Test() {
    // get info for time it took to open everything
    var stopwatch = getStopwatchService();
    stopwatch.stopTimerFor(timerEvent);
    var duration_open = stopwatch.readTimerFor(timerEvent);
    var openedMemoryUsage = pdhUtil.GetPerformanceAttributesForCurrentProcess("Process", "Private Bytes");
    stopwatch.startTimerFor(timerEvent);

    // close all files
    viewManager.doFileCloseAll();
    
    // get end info
    stopwatch.stopTimerFor(timerEvent);
    var duration = stopwatch.readTimerFor(timerEvent);
    stopwatch.resetTimerFor(timerEvent);
    var closedMemoryUsage = pdhUtil.GetPerformanceAttributesForCurrentProcess("Process", "Private Bytes");
    _openFileGC.gcCollect(); // collect!
    var collectedMemoryUsage = pdhUtil.GetPerformanceAttributesForCurrentProcess("Process", "Private Bytes");

    var openFilePS = getPythonProfilerService();
    openFilePS.dumpToFile("pyProfiler.txt","cumulative");
    openFilePS.resetStats();

    dump("Files in directory: "+_openFileTest.length+"\n");

    fls.LogMeasurement("timing", timerEvent, "start");
    fls.LogMeasurement("timing", timerEvent, "memoryStart: "+startMemoryUsage);
    var avg = duration_open/_openFileTest.length;
    dump("Opening took: "+duration_open+" Avg: "+avg+"\n");
    fls.LogMeasurement("timing", timerEvent, "files: "+_openFileTest.length+" OpenAvg: "+avg+" OpenTot: "+duration_open);
    fls.LogMeasurement("timing", timerEvent, "memoryOpen: "+openedMemoryUsage+" avg_alloc: "+((openedMemoryUsage-startMemoryUsage)/_openFileTest.length));

    avg = ((duration-duration_open)/_openFileTest.length);
    dump("Closing took: "+(duration-duration_open)+" Avg: "+avg+"\n");
    fls.LogMeasurement("timing", timerEvent, "files: "+_openFileTest.length+" CloseAvg: "+avg+" CloseTot: "+(duration-duration_open));
    fls.LogMeasurement("timing", timerEvent, "memoryClosed: "+closedMemoryUsage+" avg_free: "+((openedMemoryUsage-closedMemoryUsage)/_openFileTest.length));
    fls.LogMeasurement("timing", timerEvent, "memoryGC: "+(closedMemoryUsage-collectedMemoryUsage)+" avg_gc: "+((closedMemoryUsage-collectedMemoryUsage)/_openFileTest.length));

    avg = duration/_openFileTest.length;
    dump("Total Time: " + duration +", per file "+avg+"\n");
    fls.LogMeasurement("timing", timerEvent, "files: "+_openFileTest.length+" TAvg: "+avg+" TTot: "+duration);
    fls.LogMeasurement("timing", timerEvent, "memoryEnd: "+collectedMemoryUsage+" avg_leak: "+((collectedMemoryUsage-startMemoryUsage)/_openFileTest.length));
    fls.LogMeasurement("timing", timerEvent, "end");

    dump("OpenFileSpeed: ok\n");
    return "ok";

}

function _getFileList(dir) {
    var sfile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
    var filelist = [];
    sfile.initWithUnicodePath(dir);
    if (!(sfile.exists() && sfile.isDirectory())) {
        dump("TEST _getFileList with invalid directory "+dir+"\n");
        return null;
    }
    var dirEntries = sfile.QueryInterface(Components.interfaces.nsIFile).directoryEntries;
    while (dirEntries.hasMoreElements() && filelist.length <= testNumFiles) {
      var nextFile = dirEntries.getNext().QueryInterface(Components.interfaces.nsIFile);
      if (nextFile.isDirectory()) continue;
      filelist[filelist.length] = nextFile.URL;
    }
    if (!filelist.length) return null;
    return filelist;
}

/////////////////////////////////////////////////////////////////////////////////////////////////
function TestSuite_OpenFileSpeed_InteractiveII()
{
    var dir = BrowseForDir(testDirectory);
    if (!dir) {
        alertdialog("You must pick a test directory!");
        return false;
    }
    var got = promptDialog("How many files would you like to load?", testNumFiles, "OK", "Cancel");
    if (!got) {
        return false;
    }
    gc_setflag();
    testNumFiles = parseInt(got, 10)
    testDirectory = dir;
    timerEvent = 'file-open-close2';
    return TestSuite_OpenFileSpeedII(null);
}

function _idleOpenFile_Test() {
    viewManager.doFileOpen(_openFileTest[_openFileTestCounter]);
    _openFileTestCounter++;
    if (_openFileTestCounter < _openFileTest.length) {
        window.setTimeout('_idleOpenFile_Test()',0);
    } else {
        _finishOpenFile_Test();
    }
}


function TestSuite_OpenFileSpeedII(dir) {
    _start_OpenFile_Test(dir);
    _openFileTestCounter = 0;
    window.setTimeout('_idleOpenFile_Test()',0);
}


/////////////////////////////////////////////////////////////////////////////////////////////////

var _idleTabSwitchCount;
function _idleTabSwitch_Test() {
    viewManager.setCurrentView(viewManager.getNextView());
    _idleTabSwitchCount++;
    if (_idleTabSwitchCount < 100) {
        window.setTimeout('_idleTabSwitch_Test()',0);
    } else {
        _finishTabSwitch_Test();
    }
}

function _finishTabSwitch_Test() {
  var stopwatch = getStopwatchService();
  stopwatch.stopTimerFor(timerEvent);
  var duration = stopwatch.readTimerFor(timerEvent);
  stopwatch.resetTimerFor(timerEvent);
  getFileLoggingService().LogMeasurement("timing", timerEvent, String(duration));
}

function _start_TabSwitch_test() {
    // open some files if none are already open    
    if (viewManager.getCurrentView() == null) {
        var dir = BrowseForDir(testDirectory);
        if (!dir) {
            alertdialog("You must pick a test directory!");
            return false;
        }
        testNumFiles = 20;
        testDirectory = dir;
        files = _getFileList(testDirectory);
        // open files
        for (var i=0;i<files.length;i++) {
            dump("file: "+files[i]+"\n");
            viewManager.doFileOpen(files[i]);
        }
    }
    
    _idleTabSwitchCount = 0;
    getStopwatchService().startTimerFor(timerEvent);
    return true;
}

function TestSuite_TabSwitchSpeed_Interactive()
{
    timerEvent = '100tabSwitches';
    _start_TabSwitch_test();
    window.setTimeout('_idleTabSwitch_Test()',0);
    return;
}


/////////////////////////////////////////////////////////////////////////////////////////////////

function TestSuite_TabSwitchSpeed()
{
    timerEvent = '100tabSwitches_1';
    _start_TabSwitch_test();
    for (var i = 0; i < 100; i++) {
        viewManager.setCurrentView(viewManager.getNextView());
    }
    _finishTabSwitch_Test();
}

/////////////////////////////////////////////////////////////////////////////////////////////////

function TestSuite_MemoryFootprint()
{
    dump("measuring footprint ... ");
    
    // skip if on Linux
    var infoSvc = Components.classes['@activestate.com/koInfoService;1'].
                  getService(Components.interfaces.koIInfoService);
    if (!infoSvc.platform.match(/^win/)) {
        dump("skipping (Don't know how to query process memory usage on " +
             infoSvc.platform + ".)\n");
        return "skipped";
    }
    //XXX This does nothing useful yet.
    
    dump("ok\n");
    return "ok";
}

