/* Copyright (c) 2000-2001 ActiveState Tool Corporation.
   See the file LICENSE.txt for licensing information. */
function _repeatStr(str, aCount) {
   var res = "";
   while (--aCount >= 0)
     res += str;
   return res;
}
function koDumpDOM(node, level) {
  if (level == undefined) {
    level = 0
  }
  
  dump(_repeatStr(" ", 2*level) + "<" + node.nodeName + "\n");
  var i;
  for (i = 0; i < node.attributes.length; i++) {
    dump(_repeatStr(" ", (2*level) + 4) + node.attributes[i].nodeName + "='" + node.attributes[i].nodeValue + "'\n");
  }
  if (node.childNodes.length == 0) {
    dump(_repeatStr(" ", (2*level)) + "/>\n");
  } else {
    dump(_repeatStr(" ", (2*level)) + ">\n");
    for (i = 0; i < node.childNodes.length; i++) {
      koDumpDOM(node.childNodes[i], level + 1);
    }
    dump(_repeatStr(" ", 2*level) + "</" + node.nodeName + ">\n");
  }
}


function rebuildTree(newds) {
    // remove all the current datasources
    var tree = document.getElementById('nested-content-tree');
    var datasources = tree.database.GetDataSources();
    while (datasources.hasMoreElements()) {
        ds = datasources.getNext();
        tree.database.RemoveDataSource(ds);
    }
    tree.database.AddDataSource(newds);
    // Chris Waterson indicated that this should not be necessary, but
    // I find that it is. Check in later Mozilla builds.
    tree.builder.rebuild();
}

function rdf_addcontent() {
    dump("add rdf to list\n");
    var name = document.getElementById("URIName").value;
    var link = document.getElementById("URILink").value;
    var parent_id = "rdf:#webservices-top";
    var tree = document.getElementById('nested-content-tree');
    var rdffile = tree.getAttribute("datasources");
    if (tree.selectedItems.length > 0) {
        parent_id = new String(tree.selectedItems[0].getAttribute("id"));
    }
    if (name && link) {
        // split the id into file/id parts
        
        dump("adding to file: "+rdffile+" id: "+parent_id+" name: "+name+" link: "+link+"\n");
        rdf_addElement(rdffile, parent_id,name,link);
    }
}

function rdf_editcontent(event) {
    if (event.button == 2) {
        dump("edit rdf in list\n");
        var parent_dl = event.target.parentNode.parentNode.parentNode.parentNode;
        var parent_id = "";
        if (parent_dl.tagName.toLowerCase() == "tree") return;
        
        var tree = document.getElementById('nested-content-tree');
        koDumpDOM(tree);
        parent_id = parent_dl.getAttribute('id');
        dump("Items parent is "+parent_id+"\n");
        if (tree.selectedItems.length > 0) {
            document.getElementById("URIName").value = event.target.getAttribute('label');
            document.getElementById("URILink").value = event.target.getAttribute('link');
        }
    }
}

function rdf_addElement(rdffile, parent_id, name, link) {
    var RDF =
      Components.
      classes['@mozilla.org/rdf/rdf-service;1'].
      getService(Components.interfaces.nsIRDFService);
    var RDFC =
      Components.
      classes['@mozilla.org/rdf/container-utils;1'].
      getService(Components.interfaces.nsIRDFContainerUtils);

    var ds = RDF.GetDataSource(rdffile);
    //var ds = RDF.GetDataSource("chrome://komodo/content/test/test_rdf.rdf");
    var remote =
      ds.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource);

    var pred_subheadings = RDF.GetResource('http://home.netscape.com/NC-rdf#subheadings');
    var pred_name = RDF.GetResource('http://home.netscape.com/NC-rdf#name');
    var pred_link = RDF.GetResource('http://home.netscape.com/NC-rdf#link');

    var root = RDF.GetResource(parent_id);
    var sub_root = RDF.GetResource("rdf:"+name+"-seq");
    ds.Assert(root, pred_subheadings, sub_root, true);
    var seq_root = RDFC.MakeSeq(ds, sub_root);
    var rdflink = RDF.GetResource("rdf:"+name);
    ds.Assert(rdflink, pred_name, RDF.GetLiteral(name), true);
    ds.Assert(rdflink, pred_link, RDF.GetLiteral(link), true);
    seq_root.AppendElement(rdflink);

    remote.Flush();
    rebuildTree(ds);
}
