/* Copyright (c) 2000-2001 ActiveState Tool Corporation.
   See the file LICENSE.txt for licensing information. */



function rdf_simpledescription() {

    var RDF =
      Components.
      classes['@mozilla.org/rdf/rdf-service;1'].
      getService(Components.interfaces.nsIRDFService);
    var RDFC =
      Components.
      classes['@mozilla.org/rdf/container-utils;1'].
      getService(Components.interfaces.nsIRDFContainerUtils);

    var ds = Components.classes['@mozilla.org/rdf/datasource;1?name=in-memory-datasource'].
      createInstance(Components.interfaces.nsIRDFDataSource);  

    var root = RDF.GetResource('urn:simple-sequence');
    var links = RDF.GetAnonymousResource();
    ds.Assert(root,
              RDF.GetResource('http://home.netscape.com/NC-rdf#links'),
              links,
              true);

    var seq = RDFC.MakeSeq(ds, links); 
    var kNames = ['one', 'two', 'three'];
    for (var i = 0; i < 3; ++i) {
      var element = RDF.GetAnonymousResource();
      ds.Assert(element,
                RDF.GetResource('http://home.netscape.com/NC-rdf#name'),
                RDF.GetLiteral(kNames[i]),
                true);
      seq.AppendElement(element);
    }

    var tree = document.getElementById('simple-sequence-tree');
    tree.database.AddDataSource(ds);
    // Chris Waterson indicated that this should not be necessary, but
    // I find that it is. Check in later Mozilla builds.
    tree.builder.rebuild();
}



function rdf_simplesequence() {

    var RDF =
      Components.
      classes['@mozilla.org/rdf/rdf-service;1'].
      getService(Components.interfaces.nsIRDFService);
    var RDFC =
      Components.
      classes['@mozilla.org/rdf/container-utils;1'].
      getService(Components.interfaces.nsIRDFContainerUtils);

    var ds = Components.classes['@mozilla.org/rdf/datasource;1?name=in-memory-datasource'].
      createInstance(Components.interfaces.nsIRDFDataSource);  

    var root = RDF.GetResource('urn:simple-sequence');
    var links = RDF.GetAnonymousResource();
    ds.Assert(root,
              RDF.GetResource('http://home.netscape.com/NC-rdf#links'),
              links,
              true);

    var seq = RDFC.MakeSeq(ds, links); 
    var kNames = ['one', 'two', 'three'];
    for (var i = 0; i < 3; ++i) {
      var element = RDF.GetAnonymousResource();
      ds.Assert(element,
                RDF.GetResource('http://home.netscape.com/NC-rdf#name'),
                RDF.GetLiteral(kNames[i]),
                true);
      seq.AppendElement(element);
    }

    var tree = document.getElementById('simple-sequence-tree');
    tree.database.AddDataSource(ds);
    // Chris Waterson indicated that this should not be necessary, but
    // I find that it is. Check in later Mozilla builds.
    tree.builder.rebuild();
}

function rdf_simplesequence_kordf() {
    var comp = Components.classes["Komodo.LearnRdf"].createInstance();
    var iface = comp.QueryInterface(Components.interfaces.koILearnRdf);

    var ds = iface.rdf_simplesequence_kordf(document);

    var tree = document.getElementById('simple-sequence-tree');
    tree.database.AddDataSource(ds);
    // Chris Waterson indicated that this should not be necessary, but
    // I find that it is. Check in later Mozilla builds.
    tree.builder.rebuild();
}

function rdf_simplesequence_kodata() {
    var comp = Components.classes["Komodo.LearnRdf"].createInstance();
    var iface = comp.QueryInterface(Components.interfaces.koILearnRdf);

    var ds = iface.rdf_simplesequence_kodata(document);

    var tree = document.getElementById('simple-sequence-tree');
    tree.database.AddDataSource(ds);
    // Chris Waterson indicated that this should not be necessary, but
    // I find that it is. Check in later Mozilla builds.
    tree.builder.rebuild();
}

function rdf_nestedcontent() {

    var RDF =
      Components.
      classes['@mozilla.org/rdf/rdf-service;1'].
      getService(Components.interfaces.nsIRDFService);
    var RDFC =
      Components.
      classes['@mozilla.org/rdf/container-utils;1'].
      getService(Components.interfaces.nsIRDFContainerUtils);

    var ds = Components.classes['@mozilla.org/rdf/datasource;1?name=in-memory-datasource'].
      createInstance(Components.interfaces.nsIRDFDataSource);  

    var pred_subheadings = RDF.GetResource('http://home.netscape.com/NC-rdf#subheadings');
    var pred_name = RDF.GetResource('http://home.netscape.com/NC-rdf#name');

    var root = RDF.GetResource('urn:nested-content');
    var sub_root = RDF.GetAnonymousResource();
    ds.Assert(root, pred_subheadings, sub_root, true);
    var seq_root = RDFC.MakeSeq(ds, sub_root);
    var ch1 = RDF.GetAnonymousResource();
    ds.Assert(ch1, pred_name, RDF.GetLiteral('Intro to JS'), true);
    seq_root.AppendElement(ch1);
    var ch2 = RDF.GetAnonymousResource();
    ds.Assert(ch2, pred_name, RDF.GetLiteral('Lexical Struct'), true);
    seq_root.AppendElement(ch2);
    var ch3 = RDF.GetAnonymousResource();
    ds.Assert(ch3, pred_name, RDF.GetLiteral('Data Types and Vals'), true);
    seq_root.AppendElement(ch3);

    var sub_ch1 = RDF.GetAnonymousResource();
    ds.Assert(ch1, pred_subheadings, sub_ch1, true);
    var seq_ch1 = RDFC.MakeSeq(ds, sub_ch1);
    var ch1_1 = RDF.GetAnonymousResource();
    ds.Assert(ch1_1, pred_name, RDF.GetLiteral('JS Myths'), true);
    seq_ch1.AppendElement(ch1_1);
    var ch1_2 = RDF.GetAnonymousResource();
    ds.Assert(ch1_2, pred_name, RDF.GetLiteral('JS Versions'), true);
    seq_ch1.AppendElement(ch1_2);

    var tree = document.getElementById('nested-content-tree');
    tree.database.AddDataSource(ds);
    // Chris Waterson indicated that this should not be necessary, but
    // I find that it is. Check in later Mozilla builds.
    tree.builder.rebuild();
}

function rdf_nestedcontent_kordf() {
    var comp = Components.classes["Komodo.LearnRdf"].createInstance();
    var iface = comp.QueryInterface(Components.interfaces.koILearnRdf);

    var ds = iface.rdf_nestedcontent_kordf(document);

    var tree = document.getElementById('nested-content-tree');
    tree.database.AddDataSource(ds);
    // Chris Waterson indicated that this should not be necessary, but
    // I find that it is. Check in later Mozilla builds.
    tree.builder.rebuild();
}

function rdf_nestedcontent_kodata() {
    var comp = Components.classes["Komodo.LearnRdf"].createInstance();
    var iface = comp.QueryInterface(Components.interfaces.koILearnRdf);

    var ds = iface.rdf_nestedcontent_kodata(document);

    var tree = document.getElementById('nested-content-tree');
    tree.database.AddDataSource(ds);
    // Chris Waterson indicated that this should not be necessary, but
    // I find that it is. Check in later Mozilla builds.
    tree.builder.rebuild();
}

