/* Copyright (c) 2000-2001 ActiveState Tool Corporation.
   See the file LICENSE.txt for licensing information. */

/* Properties of the argument object (window.argumnets[0]) to this window are:
    type -'add' or 'edit' of a bookmark
    url -
    retval - boolean value for ok/cancel
    When type is add only:
    name
    description -
    shortname -
    When type is edit only:
    dir - 
*/
    
// Globals
var wsBookmarksMgr = Components.classes["@activestate.com/koBookmarkManager;1"].getService(Components.interfaces.koIBookmarkManager);
const bmdirectory = wsBookmarksMgr.rootDirectory;
const bmextension = wsBookmarksMgr.extension;
const bmrootdir = wsBookmarksMgr.rootDirectory;
var bmark;
var os = Components.classes["@activestate.com/koOs;1"].getService();
var shortnameBox, urlBox, descBox, nameBox;

var dialog;

function onLoad()  {
    dialog = {};
    dialog.shortnameBox = document.getElementById('shortnameBox');
    dialog.urlBox = document.getElementById('urlBox');
    dialog.descBox = document.getElementById('descBox');
    dialog.nameBox = document.getElementById('nameBox');
    dialog.suggestBtn = document.getElementById('suggestBtn');
    dialog.okBtn = document.getElementById('ok');
    dialog.cancelBtn = document.getElementById('cancel');

    if (window.arguments[0].type == 'edit')  {
        dialog.nameBox.value = window.arguments[0].name;
        dialog.urlBox.value = window.arguments[0].url;
        dialog.descBox.value = window.arguments[0].description;
        dialog.shortnameBox.value = window.arguments[0].shortname;
        window.title = "Edit Bookmark";
    }
    else  {
        window.title = "Add Bookmark";
    }
    
    if (window.arguments[0].url != null) 
        dialog.urlBox.value = window.arguments[0].url;

    koDoSetOKCancel(onOk, onCancel);
    koCenterWindowOnScreen();
    dialog.urlBox.focus();

    updateButtonState();
}

function onUnLoad()  {

}

function onOk()  {
    if (window.arguments[0].type == 'add')  {
        if (!createBookmark()) return false;
    }
    
    window.arguments[0].name = dialog.nameBox.value;
    window.arguments[0].url = dialog.urlBox.value;
    window.arguments[0].description = dialog.descBox.value;
    window.arguments[0].shortname= dialog.shortnameBox.value;
    window.arguments[0].retval = true;
    window.arguments[0].bmark = bmark;
    return true;
}

function onCancel()  {
    return true;
}

function updateButtonState() {

    if (dialog.urlBox.value) {
        dialog.suggestBtn.removeAttribute('disabled');
    } else {
        dialog.suggestBtn.setAttribute('disabled', 'true');
    }

    if (dialog.urlBox.value && dialog.nameBox.value && dialog.shortnameBox.value) {
        dialog.okBtn.removeAttribute('disabled');
    } else {
        dialog.okBtn.setAttribute('disabled', 'true');
    }

}

function createBookmark()  {
    // construct the file name
    var path;
    if (dialog.nameBox.value == "" || dialog.urlBox.value == "") return false;
    window.setCursor("spinning");
    if (window.arguments[0].dir != null)  {
        path = os.path.join(window.arguments[0].dir,
                    dialog.nameBox.value + bmextension);
    }
    else  {
        path = os.path.join(bmrootdir,
                    dialog.nameBox.value + bmextension);
    }
    bmark = wsBookmarksMgr.open(path);
    bmark.url = dialog.urlBox.value;
    bmark.description = dialog.descBox.value;
    bmark.shortname = dialog.shortnameBox.value;
    var errmsg = new Object();
    var success = bmark.save(dialog.nameBox.value, false, errmsg);
    window.setCursor("auto");
    if (errmsg.value) {
        alertDialog(errmsg.value);            
    }

    return success    
}

function suggestDetails() {
    window.setCursor("spinning");
    // get details from the wsdl if possible
    var bmark = Components.classes["@activestate.com/koBookmark;1"].createInstance(Components.interfaces.koIBookmark);
    bmark.url = dialog.urlBox.value;
    var errmsg = new Object();
    var success = bmark.generateFromWSDL(errmsg);
    if (!success) {
        window.setCursor("auto");
        alertDialog("Error retrieving " + bmark.url + 
                    ".  "+errmsg.value);
        return;
    }
    
    dialog.nameBox.value = bmark.name;
    dialog.descBox.value = bmark.description;
    dialog.shortnameBox.value = bmark.shortname;
    updateButtonState();
    window.setCursor("auto");
}
