/* Copyright (c) 2000-2001 ActiveState Tool Corporation.
   See the file LICENSE.txt for licensing information. */

const nsIFilePicker       = Components.interfaces.nsIFilePicker;
const nsIDirectoryServiceProvider = Components.interfaces.nsIDirectoryServiceProvider;
const nsIDirectoryServiceProvider_CONTRACTID = "@mozilla.org/file/directory_service;1";
const nsIOutlinerBoxObject = Components.interfaces.nsIOutlinerBoxObject;

var sfile = Components.classes[nsLocalFile_CONTRACTID].createInstance(nsILocalFile);
var retvals;
var filePickerMode;
var homeDir;
var current_directory;
var outliner;
var outlinerView;
var type;

var gFilePickerBundle;

function bmFilepickerLoad() {
    //gFilePickerBundle = document.getElementById("bundle_filepicker");
    outlinerView = new nsFileView();
    outlinerView.selectionCallback = onSelect;
    filePickerMode = nsIFilePicker.modeOpen;  // modeSave & modeGetFolder
    this.mDisplayDirectory = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
    this.mDisplayDirectory.initWithUnicodePath(bmdirectory);
    bmdirectory = this.mDisplayDirectory.unicodePath;

    // set the files filter to be just *.asbk
    outlinerView.setFilter("*"+bmextension);
    //outlinerView.showOnlyDirectories = true;
    // start out with a filename sort
    handleColumnClick("FilenameColumn");
    // get the home dir
    var dirServiceProvider = Components.classes[nsIDirectoryServiceProvider_CONTRACTID]
        .getService(nsIDirectoryServiceProvider);
    var persistent = new Object();
    homeDir = dirServiceProvider.getFile("Home", persistent);
    if (bmdirectory) {
        sfile.initWithUnicodePath(bmdirectory);
    }
    if (!bmdirectory || !(sfile.exists() && sfile.isDirectory())) {
        // Start in the user's home directory
        alert(bmdirectory+" does not exist. Defaulting to home directory.");
        sfile.initWithUnicodePath(homeDir.unicodePath);
    }
    gotoDirectory(sfile);
    outliner = document.getElementById("directoryOutliner");
    outliner.outlinerBoxObject.view = outlinerView;
}

function onFilterChanged(target)
{
  var filterTypes = target.getAttribute("filters");
  window.setCursor("wait");
  outlinerView.setFilter(filterTypes);
  window.setCursor("auto");
}

function onDblClick(e) {
  var t = e.originalTarget;
  if (t.localName != "outlinerbody")
    return;

  var file = outlinerView.getSelectedFile();
  if (!file)
    return;

  if (file.isSymlink()) {
    var targetFile = Components.classes[nsLocalFile_CONTRACTID].createInstance(nsILocalFile);
    targetFile.initWithUnicodePath(file.unicodeTarget);
    file = targetFile;
  }

  if (file.isDirectory()) {
    gotoDirectory(file);
  }
  else if (file.isFile()) {
    editBookmark();
  }
}

function onClick(e) {
  var t = e.originalTarget;
  if (t.localName == "outlinercol")
    handleColumnClick(t.id);
}

function convertColumnIDtoSortType(columnID) {
  var sortKey;
  
  switch (columnID) {
  case "FilenameColumn":
    sortKey = nsFileView.SORTTYPE_NAME;
    break;
  case "FileSizeColumn":
    sortKey = nsFileView.SORTTYPE_SIZE;
    break;
  case "LastModifiedColumn":
    sortKey = nsFileView.SORTTYPE_DATE;
    break;
  default:
    dump("unsupported sort column: " + columnID + "\n");
    sortKey = 0;
    break;
  }
  
  return sortKey;
}

function handleColumnClick(columnID) {
    var sortType = convertColumnIDtoSortType(columnID);
    var sortOrder = (outlinerView.sortType == sortType) ? !outlinerView.reverseSort : false;
    outlinerView.sort(sortType, sortOrder, false);
    // set the sort indicator on the column we are sorted by
    var sortedColumn = document.getElementById(columnID);
    if (outlinerView.reverseSort) {
        sortedColumn.setAttribute("sortDirection", "descending");
    } else {
        sortedColumn.setAttribute("sortDirection", "ascending");
    }
    // remove the sort indicator from the rest of the columns
    var currCol = document.getElementById("directoryOutliner").firstChild;
    while (currCol) {
        while (currCol && currCol.localName != "outlinercol")
            currCol = currCol.nextSibling;
        if (currCol) {
            if (currCol != sortedColumn) {
                currCol.removeAttribute("sortDirection");
            }
            currCol = currCol.nextSibling;
        }
    }
}

function onKeypress(e) {
    if (e.keyCode == 46) // delete
        deleteBookmark();
}

function onSelect(file) {
  dialog.start_box.setAttribute('collapsed', 'true');
  var path = file.unicodePath;
  if (file.isFile())  {
      dialog.bmPropsDeck.setAttribute('index', '1');
      type = 'bookmark';
  }
  else if (file.isDirectory())  {
      dialog.bmPropsDeck.setAttribute('index', '2');
      type = 'folder';
  }
  bmProperties(file, type); // bookmarks.js
}

function onDirectoryChanged(target)
{
  var path = target.getAttribute("label");

  var file = Components.classes[nsLocalFile_CONTRACTID].createInstance(nsILocalFile);
  file.initWithUnicodePath(path);

  if (!sfile.equals(file)) {
    gotoDirectory(file);
  }
}

function goUp() {
  try {
    var parent = sfile.parent;
  } catch(ex) { dump("can't get parent directory\n"); }

  if (parent) {
    gotoDirectory(parent);
  }
}

function gotoDirectory(directory) {
  //addToHistory(directory.unicodePath);
  window.setCursor("wait");
  outlinerView.setDirectory(directory.unicodePath);
  window.setCursor("auto");
  sfile = directory;
  var upLevelBtn = document.getElementById('upfolder-button');
  if (directory.unicodePath != bmdirectory)
      upLevelBtn.setAttribute('disabled', 'false');
  else
      upLevelBtn.setAttribute('disabled', 'true');
  
  current_directory = directory.unicodePath;
  document.getElementById('foldertitle').setAttribute('value', directory.unicodeLeafName);
   // nothing is selected when you enter a directory, so disable delete button
  dialog.delBtn.setAttribute('disabled', 'true');
}

