/* Copyright (c) 2000-2001 ActiveState Tool Corporation.
   See the file LICENSE.txt for licensing information. */
   
// Globals

var wsBookmarksMgr = Components.classes["@activestate.com/koBookmarkManager;1"].getService(Components.interfaces.koIBookmarkManager);
const bmdirectory = wsBookmarksMgr.rootDirectory;
const bmextension = wsBookmarksMgr.extension;
const bmrootdir = wsBookmarksMgr.rootDirectory;
var dialog = new Object();
var bmark;

var os = Components.classes["@activestate.com/koOs;1"].getService();
var observerSvc = Components.classes["@mozilla.org/observer-service;1"].
                  getService(Components.interfaces.nsIObserverService);

var observer = {
    Observe: function(subject, topic, data) {
        updateInsertButton();
    }
}

function OnLoad()  {
    // Set up UI elements
    dialog.start_box = document.getElementById('start_box');
    dialog.bmProps_box = document.getElementById('bmProps_box');
    dialog.folderProps_box = document.getElementById('folderProps_box');
    dialog.bmPropsDeck = document.getElementById('bmPropsDeck');
    dialog.bmurl = document.getElementById('bmurl');
    dialog.bmdesc = document.getElementById('bmdesc');
    dialog.bmshortname = document.getElementById('bmshortname');
    dialog.bmname = document.getElementById('bmname');
    dialog.foldername = document.getElementById('foldername');

    dialog.folderdate = document.getElementById('folderdate');
    dialog.addBtn = document.getElementById('addBtn');
    dialog.delBtn = document.getElementById('delBtn');
    dialog.refreshBtn = document.getElementById('refreshBtn');
    dialog.editBtn = document.getElementById('editBtn');
    dialog.insertBtn = document.getElementById('ok');
    dialog.cancelBtn = document.getElementById('cancel');
    dialog.toolboxBtn = document.getElementById('toolboxBtn');
    dialog.generateBtn = document.getElementById('generateBtn');
    
    bmFilepickerLoad();
    
    dialog.insertBtn.setAttribute("label", "Insert");
    dialog.cancelBtn.setAttribute("label", "Close");
    dialog.editBtn.setAttribute('disabled', 'true');
    dialog.delBtn.setAttribute('disabled', 'true');
    dialog.refreshBtn.setAttribute('disabled', 'true');
    dialog.insertBtn.setAttribute('disabled', 'true');
    dialog.toolboxBtn.setAttribute('disabled', 'true');
    dialog.generateBtn.setAttribute('disabled', 'true');
    
    koDoSetOKCancel(insertBookmark, OnClose);
    koCenterWindowOnScreen();

    observerSvc.AddObserver(observer, 'post_activate_view');
    observerSvc.AddObserver(observer, 'current_view_language_changed');
    observerSvc.AddObserver(observer, 'view_closed');
}

function OnUnload() {
    observerSvc.RemoveObserver(observer, 'view_closed');
    observerSvc.RemoveObserver(observer, 'current_view_language_changed');
    observerSvc.RemoveObserver(observer, 'post_activate_view');
}

function OnClose()  {
    window.close();
}

function updateInsertButton() {
    var view = opener.gLastFocusedViewManager.getCurrentView();
    if (view) {
        var insertSvc = view.py_inst.sourceFile.
                        getLanguageBlockAtPosition(0).language.
                        getLanguageService(Components.interfaces.
                                           koIWSInsertLanguageService);
        dialog.insertBtn.setAttribute('disabled', insertSvc ? 'false' : 'true');
    } else {
        dialog.insertBtn.setAttribute('disabled', 'true');
    }
}

function bmProperties(file, type)  {
    var path = file.unicodePath;
    var leaf = file.unicodeLeafName;
    if (type == 'bookmark')  {
        // open
        bmark = wsBookmarksMgr.open(path);
        updateProps(type, bmark.name, bmark.url, bmark.description, bmark.shortname);
        dialog.editBtn.setAttribute('disabled', 'false');
        dialog.refreshBtn.setAttribute('disabled', 'false');
        dialog.toolboxBtn.setAttribute('disabled', 'false');
        dialog.generateBtn.setAttribute('disabled', 'false');
	updateInsertButton();
    }
    else if (type == 'folder')  {
        updateProps(type, leaf, formatDate(file.lastModificationDate));
        dialog.editBtn.setAttribute('disabled', 'true');
        dialog.refreshBtn.setAttribute('disabled', 'true');
	dialog.insertBtn.setAttribute('disabled', 'true');
        dialog.toolboxBtn.setAttribute('disabled', 'true');
        dialog.generateBtn.setAttribute('disabled', 'true');
    }
    dialog.delBtn.setAttribute('disabled', 'false');
}

function updateProps(type, arg1, arg2, arg3, arg4)  {
    var a, b;
    if (type == 'bookmark')  {
        // long strings will only wrap using <html> if there is spaces in it
        dialog.bmshortname.setAttribute('value', arg1);
        dialog.bmurl.setAttribute('value', arg2);
        dialog.bmurl.setAttribute('tooltiptext', arg2);
        var bmdesc = window.frames[0].document;
        bmdesc.open();
        bmdesc.write('<BODY STYLE="background-color: -moz-Dialog;">');
        bmdesc.write('<FONT FACE="tahoma, arial" STYLE="font-size: 11px;">');
        bmdesc.write(arg3);
        bmdesc.write('</FONT>');
        bmdesc.write('</BODY>');
        bmdesc.close();
        dialog.bmname.setAttribute('value', arg4);
    }
    else if (type == 'folder')  {
        dialog.foldername.setAttribute('value', arg1);
        dialog.folderdate.setAttribute('value', arg2);
    }
}


// XXX insertWebService() and getWSInserter() are near-duplicates of the
// functions of the same name in kombo.js.  These should be factored out
// into a common file somewhere.
function insertWebService(shortname, url) {
    // First, run the WS setup wizard for this language if it has not been
    // run before.
    var view = opener.gLastFocusedViewManager.getCurrentView();
    if (!view) return 0;
    var language = view.py_inst.language;
    WSSetup_SetupIfHaveNotAlready(language)

    // Do the WS insertion magic.
    var wsinserter = getWSInserter();
    if (wsinserter) {
	var scin = view._scimoz;
	wsinserter.insert(scin, 
			  scin.currentPos, 
			  shortname, 
			  url);
    }
    return 1;
}

function getWSInserter() {
    var v = opener.gLastFocusedViewManager.getCurrentView();
    var wsinserter = v.py_inst.sourceFile.getLanguageBlockAtPosition(0).language.
        getLanguageService(Components.interfaces.koIWSInsertLanguageService);
    return wsinserter;
}

function insertBookmark()  {
    if (insertWebService(bmark.shortname, bmark.url)) {
        OnClose();
    }
}

function addBookmark()  {
    var obj = new Object();
    obj.type = 'add';
    obj.dir = current_directory;
    obj.url = null;
    obj.retval = false;
    // fix case where toc is deleted, but folders exist
    wsBookmarksMgr.createFolder(current_directory);
    window.openDialog("chrome://komodo/content/webservices/bmedit.xul", 
               "komodo_wsbmedit",
               "chrome,close=yes,modal", obj);
    
    if (obj.retval)  { // ok was clicked
        refreshList();
        outlinerView.selectionChanged();
    }
}

function editBookmark()  {
    var obj = new Object();
    obj.type = 'edit';
    obj.name = bmark.name;
    obj.url = bmark.url;
    obj.description = bmark.description;
    obj.shortname = bmark.shortname;
    obj.retval = false;
    window.openDialog("chrome://komodo/content/webservices/bmedit.xul", 
               "komodo_wsbmedit",
               "chrome,close=yes,modal", obj);
    
    if (obj.retval)  { // ok was clicked
        updateProps('bookmark', obj.name, obj.url, obj.description, obj.shortname)
        updateBookmark(obj);
        refreshList();
    }
}

function updateBookmark(bookmark)  {
    bmark.url = bookmark.url;
    bmark.description = bookmark.description;
    bmark.shortname = bookmark.shortname;
    // fix case where toc is deleted, but folders exist
    wsBookmarksMgr.createFolder(current_directory);
    var errmsg = new Object();
    if (!bmark.save(bookmark.name, false, errmsg)) {
        alertDialog("Error saving " + bookmark.name + 
                    ".  "+errmsg.value);
    }
}

function deleteBookmark()  {
    var file = outlinerView.getSelectedFile();
    var prompt;
    var exists = file.exists();
    if (exists)  {
        if (file.isDirectory())
            prompt = "Are you sure that you want to delete the bookmark folder \"" + file.unicodeLeafName + "\" and all bookmarks contained within?";
        else if (file.isFile()) {
            prompt = "Are you sure that you want to delete the bookmark \"" + file.unicodeLeafName + "\"?";
        }

        var confirm = alertDialog(prompt, false, false, "Ok", "Cancel")

        try  {
            if (confirm=="Ok") {
                wsBookmarksMgr.remove(file.path);
            }
        }
        catch(e)  {
            // XXX replace this with a better error message
            alertDialog("Unable to delete the bookmark entry \"" + file.unicodeLeafName + "\".");
        }
        if (confirm=="Ok")
            refreshList();
            outlinerView.selectionChanged();
    }
}

function newFolder()  {
    // prompt for folder
    var prompt = "New bookmarks folder name";
    var defaultResponse = "New folder";
    var res = promptDialog (prompt, defaultResponse);
    if (res != null)  {
        res = os.path.join(current_directory, res);
        createFolder(res);
    }
}

function createFolder(path)  {
    const DIRECTORY = 0x01;
    var dir = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
    dir.initWithUnicodePath(path);
    var aPermissions = 0755;  // default r/w
    var retval = false;
    
    try  {
        if (!dir.exists())  {
            //dir.create(DIRECTORY, parseInt(aPermissions) );
            wsBookmarksMgr.createFolder(dir.path);
            retval = true;
        }
        else {
            alertDialog("The file or folder \"" + dir.unicodeLeafName + "\" already exists.");
        }            
    }
    catch (e)  {
        // XXX replace this with a better error message
        alertDialog("Unable to create the new bookmark folder \"" + dir.unicodeLeafName + "\".");
        retval = false;
    }
    if (retval)  {
        refreshList();
        onSelect(dir)
    }
    else  {
        return false;
    }
    return true;
}

function refreshList()  {
    var dir = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
    dir.initWithUnicodePath(current_directory);
    gotoDirectory(dir); // this will refresh the listing
}

function refreshWSDL() {
    var errmsg = new Object();
    var success = bmark.refreshWSDL(errmsg);
    if (!success) {
        alertDialog("Error retrieving " + bmark.url + 
                    ".  "+errmsg.value);
    }
}

function helpBookmark() {
    path = os.path.join(bmrootdir,
                    bmark.name + ".html");
    doHelp(path);
}

function addToToolbox() {
    opener.addWSBookmarkToToolbox(bmark,bmark.url);
}

function doGenerateProxy() {
    opener.generateWebServiceProxy(bmark.shortname,bmark.url);
}
