/* Copyright (c) 2000-2001 ActiveState SRL. 
   See the file LICENSE.txt for licensing information. */

/* Web Services Setup Wizard.
 *
 * window.arguments[0] should be an object with the following
 * attributes:
 *  "implicit"    true iff the Wizard was launched implicitly
 *  "language"    set to the language in whic context this Wizard wa
 *                launched, if any.
 */


//---- globals

// wizard data (Note: Mozilla's wizard "infrastructure" has a mechanism
// for persisting data for each panel. I don't want to learn that now
// and instead will just use globals in this, the parent of each panel.
var wd_language = null;
var wd_installation = null;
var wd_completionState = null;
var wd_setupLog = null;

// Navigation set for wizard panes

function _Next_AfterChooseInstallation() {
    return (wd_language == "PHP"? 'wsSetup_ChooseModuleDir'
            : 'wsSetup_ReadyToInstall');
}

function _Previous_BeforeReadyToInstall() {
    return (wd_language == "PHP"? 'wsSetup_ChooseModuleDir'
            : 'wsSetup_ChooseInstallation');
}

var wizardMap = {
    wsSetup_Intro: {
        previous: null,
        next: "wsSetup_ChooseInstallation",
        finish: false },
    wsSetup_WantToSetup: {
        previous: null,
        next: "wsSetup_ChooseInstallation",
        finish: false },
    wsSetup_ChooseInstallation: {
        previous: null,
        next: _Next_AfterChooseInstallation,
        finish: false },
    wsSetup_ChooseModuleDir: {  // for PHP only
        previous: "wsSetup_ChooseInstallation",
        next: "wsSetup_ReadyToInstall",
        finish: false },
    wsSetup_ReadyToInstall: {
        previous: _Previous_BeforeReadyToInstall,
        next: "wsSetup_Installing",
        finish: false },
    wsSetup_Installing: {
        previous: null,
        next: null,
        finish: false },
    wsSetup_Warning: {
        previous: null,
        next: null,
        finish: true }
}

var wizardManager = null;
var wsSetupSvcs = {
    "Perl": null,
    "PHP": null,
    "Python": null
    }



//---- interface routines for wsSetupWizard.xul

function OnLoad(contentFrameId)
{
    // instantiate the Wizard Manager
    wizardManager = new WizardManager(contentFrameId, null, null,
                                      wizardMap);
    wizardManager.URL_PagePrefix = "chrome://komodo/content/webservices/setup/";
    wizardManager.URL_PagePostfix = ".xul";

    // set the button handler functions
    wizardManager.SetHandlers(null,         // onNext
                              null,         // onBack
                              onFinish,       // onFinish
                              onCancel, // onCancel
                              null,     // onPageLoad
                              null);    // wizard button enablingFunc

    // set wizard data for the panels
    wd_language = window.arguments[0].language;
    
    // load the start panel
    // - explicit launch of wizard: Intro panel
    // - implicit launch of wizard: WantToSetup panel
    var startPanel = null;
    if (window.arguments[0].implicit) {
        startPanel = "wsSetup_WantToSetup";
    } else {
        startPanel = "wsSetup_Intro";
    }
    wizardManager.LoadPage(startPanel, false);

    moveToAlertPosition();
}


function onCancel()
{
    // First, ensure that the user wants to cancel.
    var wantToCancel = yesNoDialog("Are you sure you want to cancel "
                                   + "installing Web Services support?",
                                   "No");    // default answer

    // Second, go to the "Warning" panel.
    if (wantToCancel == "Yes") {
        wd_completionState = "cancelled";
        wizardManager.LoadPage("wsSetup_Warning", false);
    }
}


function onFinish() {
    window.close();
}


