from xpcom import components, ServerException

from koLanguageServiceBase import *

class koADALanguage(KoLanguageBase):
    name = "Ada"
    _reg_desc_ = "%s Language" % name
    _reg_contractid_ = "@activestate.com/koLanguage?language=%s;1" \
                       % (name)
    _reg_clsid_ = "{9A1F735F-38A7-4de6-9CDD-B60E057F5049}"

    defaultExtension = ".ada"
    
    def get_lexer(self):
        if self._lexer is None:
            self._lexer = KoLexerLanguageService()
            self._lexer.setLexer(components.interfaces.ISciMoz.SCLEX_ADA)
            self._lexer.setKeywords(0, self._keywords)
            self._lexer.supportsFolding = 0
        return self._lexer


    _keywords = ["abort", "abs", "abstract", "accept", "access"
                 "aliased", "all", "and", "array", "at", "begin", "body",
                 "case", "constant", "declare", "delay", "delta",
                 "digits", "do", "else", "elsif", "end", "entry",
                 "exception", "exit", "for", "function", "generic",
                 "goto", "if", "in", "is", "limited", "loop", "mod",
                 "new", "not", "null", "of", "or", "others", "out",
                 "package", "pragma", "private", "procedure",
                 "protected", "raise", "range", "record", "rem",
                 "renames", "requeue", "return", "reverse",
                 "select", "separate", "subtype", "tagged",
                 "task", "terminate", "then", "type", "until", "use",
                 "when", "while", "with", "xor"]

