# Copyright (c) 2000-2001 ActiveState Tool Corporation.
# See the file LICENSE.txt for licensing information.

from xpcom import components, _xpcom
import threading, time

PROXY_SYNC = 1
PROXY_ASYNC = 2
PROXY_ALWAYS = 4

proxyMgr = components.classes['@mozilla.org/xpcomproxy;1'].createInstance(components.interfaces.nsIProxyObjectManager)
EventIID = components.interfaceInfoManager.GetIIDForName("koIAsyncEvent")

def CreateEventQueueService():
    queueSvc = _xpcom.GetGlobalServiceManager().GetService("component://netscape/event-queue-service",
                                                           components.interfaces.nsIEventQueueService)
    queueSvc.CreateThreadEventQueue()
    queueSvc.PushThreadEventQueue()
    q = proxyMgr.getProxyForObject(None,  # proxy onto the UI thread
                                   components.interfaces.nsIEventQueueService,  
                                   queueSvc,
                                   PROXY_ASYNC | PROXY_ALWAYS)
    return q

def GetThreadEventQueue(queueSvc):
    return queueSvc.GetThreadEventQueueForCurrentThread()


class TestOutsideComponent:
    _com_interfaces_ = components.interfaces.koIAsyncEvent
    _reg_clsid_ = "{32D6FE52-18B5-4ed0-A077-28B1D0E4F142}"
    _reg_contractid_ = "TestOutsideComponent"
    def set_incoming(self, incomingProxy):
	    self._incoming = incomingProxy
    def doEvent(self, text):
	    print "event in outside component", text 
	    self._incoming.doEvent(text + " from outside component!")


class koAsyncNotifier:
    """ This component creates the proxy back to the UI thread and
    starts the new Python thread"""
    
    _com_interfaces_ = components.interfaces.koIAsyncNotifier
    _reg_clsid_ = "{0529D0D6-AB24-4c36-8879-D827B55F9901}"
    _reg_contractid_ = "Komodo.AsyncNotifier"

    def hookEvents( self, param ):
        global queueSvc
        self.outside = None
        queueSvc = CreateEventQueueService()
	self.incomingProxy = proxyMgr.getProxyForObject(None,  # proxy onto the UI thread
                                                        components.interfaces.koIAsyncEvent,  
                                                        param,
                                                        PROXY_ASYNC | PROXY_ALWAYS)
	self.incomingProxy.doEvent("got incoming proxy")
        print "doEvent"
	self.thread = threading.Thread(target=self.run)

    def startTest(self):
        print 'startTest'
        self.thread.start() # this calls the run method below
        while self.outside is None:
            print self.outside
            time.sleep(0.05)
        # Want this to be ASYNC but crashes ensue...
	self.outgoingProxy = proxyMgr.getProxyForObject(self.queue,
						   components.interfaces.koIAsyncEvent,
						   self.outside,
						   PROXY_ASYNC | PROXY_ALWAYS)
        print 'found it'
        # ... HERE ... if the above proxy is ASYNC.
        self.incomingProxy.registerProxy(self.outgoingProxy)
        print 'registered'
	
    def run(self):
        print 'running in new thread'
        print 'about to get queue'
	self.queue = GetThreadEventQueue(queueSvc)
        print "got Queue"
	outside = TestOutsideComponent()
	outside.set_incoming(self.incomingProxy)
        self.outside = outside
        print "set outside proxy"
	
