#!python
# Copyright (c) 2000-2001 ActiveState Tool Corporation.
# See the file LICENSE.txt for licensing information.


import sys, os, shutil
import string
from xpcom import components, _xpcom, Exception
import time

class StackViewerException(Exception):
       pass

class KoStackMonitor:
   _com_interfaces_ = [components.interfaces.koIStackMonitor]
   _reg_desc_ = "Komodo Stack Viewer Monitor"
   _reg_clsid_ = "{E23C5E08-0DAF-42da-8430-A981B8E1204E}"
   _reg_contractid_ = "@activestate.com/StackMonitor;1"

   def __init__(self):
      self.monitored = None
      self.getVariableOfStack = "true"
   
   def notifyChange(self, notices):
       for notice in notices:
              print "%s" %(notice)
   def setStackFlag(self, flag):
       self.getVariableOfStack = flag
       print "flag= %s" %(self.getVariableOfStack)


class KoStackViewer:
   _com_interfaces_ = [components.interfaces.koIStackRegistry, components.interfaces.koIDebuggerEvents]
   _reg_desc_ = "Komodo Stack Viewer"
   _reg_clsid_ = "{A64A4DB4-9FD4-4ffc-8569-502C02D87FA8}"
   _reg_contractid_ = "@activestate.com/StackViewer;1"

   def __init__(self):
#       self.monitored = KoStackMonitor()
       self.sm = _xpcom.GetGlobalServiceManager()
       self.kodebugger = self.sm.getService("@activestate.com/debugger;1",
                                          components.interfaces.koIDebugger)
       self.getVariableOfStack = "false"
#       cookie = self.kodebugger.addListener(self)

   def onStateChange(self, newState, stateExtra): 
       return
#       self.parseElement ()

   def addNewVar(self, fnname, varname):
          print "addNewVar......\n"
          
   def getNewValue(self, koInstance, fnname, varname):
          print "getNewValue......\n"
          
   def setBreakCond(self, fnname, condition):
          print "setBreakCond......\n"
          
   def registerBroadcast(self, koInstance):
       print "Register Broadcast......\n"
       self.koInstance = koInstance
       self.parseElement()
       print "...................\n"
#       cookie = self.kodebugger.addListener(self)
   def setRetrieveFlag(self, flag):
       self.getVariableOfStack = flag
       
   def parseElement(self):
       frames = self.kodebugger.enumStackFrames()
       for frame_index in range(len(frames)):
              frame = frames[frame_index].QueryInterface(components.interfaces.koIDebugStackFrame)
              self.koInstance.GetNewStack(frame.description)
              print self.getVariableOfStack
              if self.getVariableOfStack == "true":
                     frame.enumContext("globals", context, count)
                     for index in range(len(context)):
                            debugProperty = context[index].QueryInterface(components.interfaces.koIDebugProperty)
                            if debugProperty.hasChildren:
                                   self.koInstance.GetNewVar(frame.description, debugProperty.name, debugProperty.value, 'global.container')
                            else:
                                   self.koInstance.GetNewVar(frame.description, debugProperty.name, debugProperty.value, 'global')
                     frame.enumContext("locals", context, count)
                     for index in range(len(context)):
                            debugProperty = context[index].QueryInterface(components.interfaces.koIDebugProperty)
                            if debugProperty.hasChildren:
                                   self.koInstance.GetNewVar(frame.description, debugProperty.name, debugProperty.value, 'local.container')
                            else:
                                   self.koInstance.GetNewVar(frame.description, debugProperty.name, debugProperty.value, 'local')

class koIDebuggerEvents:
    _com_interfaces_ = components.interfaces.koIDebuggerEvents
    def onStateChange( self, state, stateExtra):
        if state == components.interfaces.koIDebugger.DBG_STATE_STOPPED:
            print "stopped"
        elif state == components.interfaces.koIDebugger.DBG_STATE_RUNNING:
            print "running"
        elif state == components.interfaces.koIDebugger.DBG_STATE_BREAK:
            print "break"
        else:
            print "** unknown **"
