from xpcom import components, ServerException

from koLanguageServiceBase import *

class koVisualBasicLanguage(KoLanguageBase):
    name = "VisualBasic"
    _reg_desc_ = "%s Language" % name
    _reg_contractid_ = "@activestate.com/koLanguage?language=%s;1" \
                       % (name)
    _reg_clsid_ = "{7B83199C-6C30-43ef-9087-329831FC6425}"

    defaultExtension = ".vb"
    
    def get_lexer(self):
        if self._lexer is None:
            self._lexer = KoLexerLanguageService()
            self._lexer.setLexer(components.interfaces.ISciMoz.SCLEX_VB)
            self._lexer.setKeywords(0, self._keywords)
            self._lexer.supportsFolding = 0
        return self._lexer


    _keywords = ["addressof", "and", "appactivate", "as",
                 "base", "beep", "binary", "boolean", "byref", "byte",
                 "byval", "call", "case", "chdir", "chdrive", "close",
                 "compare", "const", "currency", "date", "decimal",
                 "declare", "deftype", "deletesetting", "dim", "do",
                 "double", "each", "else", "empty", "end", "enum",
                 "eqv", "erase", "error", "event", "exit", "explicit",
                 "false", "filecopy", "for", "friend", "function",
                 "get", "gosub", "goto", "if", "imp", "implements",
                 "input", "integer", "is", "kill", "len", "let",
                 "line", "load", "lock", "long", "loop", "lset", "me",
                 "mid", "mkdir", "mod", "name", "new", "next", "not",
                 "nothing", "null", "on", "open", "option",
                 "optional", "or", "paramarray", "print", "private",
                 "property", "public", "put", "raisevent",
                 "randomize", "redim", "rem", "reset", "resume",
                 "rset", "savepicture", "savesetting", "seek",
                 "select", "sendkeys", "set", "setattr", "single",
                 "static", "step", "stop", "string", "sub", "time",
                 "type", "then", "time", "to", "true", "unload",
                 "unlock", "wend", "while", "width", "with",
                 "withevents", "write", "xor"]

