
"""Shim for the true 'pywintypes' module.

This is a HACK.

This module is implemented in PyWinTypesXX.dll installed in the system
directory. On Komodo installer builds, i.e. where Python is siloed, the
registry entries required for Python to map 'import pywintypes' to
<systemdir>\\PyWinTypesXX.dll are *not* there (because it is a pain to
get MSI to do this as intended). To work around this problem this shim
module is placed on the import path for Komodo installer builds and it
will replace itself with the actual pywintypes module.
"""

import os
import sys
import win32api
import imp

sysDir = win32api.GetSystemDirectory()
major, minor = sys.version_info[:2]
imp.load_dynamic('pywintypes',
                 os.path.join(sysDir, 'PyWinTypes%d%d.dll'\
                                      % (major, minor)))

